#include "buffer_cm.h"

/**********************************************************
INIT
**********************************************************/
void BUFFER_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create buffer Flow RX\n");
	//Create Bufferflow
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (control_id*buffer_id)%(control_id+buffer_id);
	fconf.name = "buffer_flow_rx";
	buffer_flow_rx = NewFlow(buffer_id, control_id, fconf);
	if (buffer_flow_rx<0) UnrecoveryError("Could not create flow with Buffer");
	WriteLog(logCMFile, "Bufferflow_rx: OK\n");


	WriteLog(logCMFile, "Create buffer flow TX\n");
	//Create Randoflow
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1500;
	fconf2.magic = (buffer_id*rando_id)%(buffer_id+rando_id);
	fconf2.name = "Buffer_flow_tx";
	buffer_flow_tx = NewFlow(buffer_id, rando_id, fconf2);
	if (buffer_flow_tx<0) UnrecoveryError("Could not create flow with Randomizer");
	WriteLog(logCMFile, "Bufferflow_tx: OK\n");

	n_times=0;
	lee_archivo("./readme",frase,n_times,L_MAX);
        n_times++;//numero de veces
	char2bin(v_in,frase,L_MAX);  //Convierte frase a binario
	readfile=0;
	pt=0;
	time_slot=0;
	lastmod=1;
	lastmode=0;
	lastsnr=0;

}

/*************************************************************
STOP
************************************************************/
void BUFFER_Stop() {

	DeleteFlow(buffer_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Buffer_flow_rx\n");

	DeleteFlow(buffer_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Buffer_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(buffer_id);

	exit(0);
}





/****************************************************************
RUN
****************************************************************/
void BUFFER_Run(){

	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n=0,p, prova;
	c2buffer flow_rx;
	buffer2rand flow_tx;
	int info[864];


	if(GetFlowStatus(buffer_flow_rx))
	{
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(buffer_flow_rx,sizeof(flow_rx),&flow_rx);
		if (n>0)
		{
//			sprintf(log_msg,"bits2read %d", flow_rx.bits2read);
//			WriteLog(logCMFile, log_msg);
//			printf("puntero %d\n",pt);

			if (flow_rx.mod==lastmod && flow_rx.mode==lastmode && (int)flow_rx.es_ovr_n0==lastsnr){

			}
			else
			{
				pt=0;
				lastmod=flow_rx.mod;
				lastmode=flow_rx.mode;
				lastsnr=(int)flow_rx.es_ovr_n0;
			}


			for (p=0; p<flow_rx.bits2read; p++)
			{

				if(readfile)
				{
      		      			lee_archivo("./readme",frase,n_times,L_MAX);
           	 			n_times++;//numero de veces
        	    			char2bin(v_in,frase,L_MAX);  //Convierte frase a binario
					readfile=0;
					pt=0;
    				}

				info[p]=v_in[p+pt];
//				sprintf(log_msg,"[%d]%d\n",(p+pt),v_in[p+pt]);
//				WriteLog(logCMFile, log_msg);

				if ((p+pt)==L_MAX)
					readfile=1;
			}
//			WriteLog(logCMFile, log_msg);

			pt+=flow_rx.bits2read;

			flow_tx.length=bin2char(info, flow_tx.info, flow_rx.bits2read);

/*			WriteLog(logCMFile, "Transmitted buffer");
			for (p=0; p<flow_tx.length; p++)
			{
				sprintf(log_msg,"[%d]%d\n",p,flow_tx.info[p]);
				WriteLog(logCMFile, log_msg);
			}
*/
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.cconv=flow_rx.cconv;
			flow_tx.interl=flow_rx.interl;
			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;

			if(GetFlowStatus(buffer_flow_tx))
			{
				n=WriteFlow(buffer_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
				if (n>0)
					WriteLog(logCMFile, "HE ESCRIT!!!!!!!!!!!!!!!!!!!!!!!!");
			}

		}
		else
		{
			WriteLog(logCMFile, "There is no flow to read");
		}
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Buffer time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

