#include <stdio.h>
#include <math.h>
#include "estadisticas_cm.h"

#define N 192



void char2bin (int vout[], unsigned char code)
{
	int  i,k;
	int  remain;

	
		for (k=0; k<8; k++)
		{
			remain = code % 2;
			code = code / 2;
			vout[k]=remain;
		}
	
	//return (bytes*8);
}

/* This function can be drawn with two probabilities of error, s, 1. The BER total running throughout the code, 2.Parcial with SER, running only the level of symbol processing */ 
// If action = 1: BER total, if action =- 1: BE partial 
// Bits: depending on the modulation in which we are simulating, # bit vary.



void truncar (symbol nro[192]){
	long x_re[192],x_im[192],i;
	for(i=0;i<192;i++){
		x_re[i] = 100*nro[i].re;
		x_im[i] = 100*nro[i].im;
	}
	for(i=0;i<192;i++){
		nro[i].re = (float)x_re[i]/(float)100;
		nro[i].im = (float)x_im[i]/(float)100;
	}
}



int ber (int bits, int accion, char *fitxer1, char *fitxer2, symbol *inicial, symbol *final, int mod)

{
	int maxdB=15,mindB=0;
	char mode[]="prueba";
	
	
	FILE *f1,*f2,*f3,*compar;

	char p1,p2;
	int bitf1[8],bitf2[8];
	char fitxer[50];
	char resultats[50];
	char tmp[60];
	int symb=bits/mod;

	int t,i,j;
	float BER=0.0,SER=0.0;
	int errors=0;//bits=0;

	compar= fopen ("compar.csv","w");
	sprintf(resultats,"BER%s.txt",mode);

	f3=fopen(resultats,"a");

	sprintf(tmp,"| MODE    | SNR(dB) | ERRORS  | BITS    | BER      |\n");
	fprintf(f3,tmp);
	sprintf(tmp,"----------------------------------------------------\n");
	fprintf(f3,tmp);

	if (accion == 1)
	{
		for (i=0;i<maxdB;i++){
		
			f2=fopen("rfc793.txt","r");
			sprintf(fitxer,"%s%ddB.txt",mode,i);
			f1=fopen(fitxer,"r");
			if((f1==NULL)||(f2==NULL))
			{
				printf("Error al abrir fichero\n");
				exit(0);           
			}
			while (!feof(f1))
			{
				fscanf(f1,"%c",&p1); 
				fscanf(f2,"%c",&p2);
				char2bin (bitf1, p1);
				char2bin (bitf2, p2);
				for (t=0;t<8;t++){
					if (bitf1[t]!=bitf2[t]) errors++;
				}
				bits=bits+8;
			}
			BER= (float)(errors)/(float)(bits);
			sprintf(tmp,"| %7s | %7d | %7d | %7d | %7f |\n",mode,i,errors,bits,BER);
			fprintf(f3,tmp);

			fclose(f1);
			fclose(f2);
		
		}

	}

	if(accion ==-1)
	{
		/*compare initial symbol to a final symbol*/

		printf("Estoy dentro de compara\n");

		for(j=0;j<N;j++)
		{
			inicial[j].re= inicial[j].re ;
			inicial[j].im= inicial[j].im ;
			final[j].re= final[j].re ;
			final[j].im= final[j].im ;

			fprintf(compar,"%f;",inicial[j].re);
			fprintf(compar,"%f;",inicial[j].im);

			fprintf(compar,"%f;",final[j].re);
			fprintf(compar," %fi\n",final[j].im);

			truncar(inicial);
			truncar(final);	
			
			switch (mod)
			{
				case 1:

					if(((final[j].re-inicial[j].re)>0.999) || ((final[j].re-inicial[j].re)<-0.999) || ((final[j].im-inicial[j].im)>0.999) || ((final[j].im-inicial[j].im)<-0.999))
					errors++;
				break;
				case 2:
					if(((final[j].re-inicial[j].re)>0.699) || ((final[j].re-inicial[j].re)<-0.699) || ((final[j].im-inicial[j].im)>0.699) || ((final[j].im-inicial[j].im)<-0.699))
					errors++;
				break;

				case 4:
					if(((final[j].re-inicial[j].re)>0.299) || ((final[j].re-inicial[j].re)<-0.299) || ((final[j].im-inicial[j].im)>0.299) || ((final[j].im-inicial[j].im)<-0.299))
					errors++;
				break;

				case 6:
					if(((final[j].re-inicial[j].re)>0.149) || ((final[j].re-inicial[j].re)<-0.149) || ((final[j].im-inicial[j].im)>0.149) || ((final[j].im-inicial[j].im)<-0.149))
					errors++;
				break;
			}
				

		}


		printf("Symbols Error:%d\n",errors); /* printf a eliminar despues de las pruebas */
		printf("Symbols:%d\n",symb);


		SER= (float)(errors)/(float)(symb);
		sprintf(tmp,"| %7s | %7d | %7d | %7d | %7f |\n",mode,i,errors,bits,SER);
		fprintf(f3,tmp);
	
		}
	
	printf("Valor de SER:%f\n",SER);

	fclose(f3);	 

	return(0);
}
