#include "controlmod_cm.h"


int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("CONTROL  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:d:")) != -1)
		switch(c){
		case 'm':
        		control_id=atoi(optarg);
			printf("Control id: %d\n",control_id);
        	break;
		case 'd':
        		buffer_id=atoi(optarg);
			printf("Buffer id: %d\n",buffer_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (control_id<0 || buffer_id<0)
	{
		printf("Need two mandatory parameter: -m <my_control_id> -d <buffer_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"CONTROL");
	n=InitCommManagerN(control_id,modulename);
	if(n<0) return(-1);


	printf("Register module CONTROL: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			CONTROL_Init();
			CONTROL_Stat_Init();
		}
		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			CONTROL_Stat_Run0();
			CONTROL_Run();
			CONTROL_Stat_Run1();
		}
		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			CONTROL_Stat_Stop();
			CONTROL_Stop();
		}
	}

	return(1);

}
