#include "controlmod_cm.h"


/**********************************************************
INIT
**********************************************************/
void CONTROL_Init()
{
  struct flow_config fconf;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	
	WriteLog(logCMFile, "Create Controlflow\n");
	//Create Controlflow
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (control_id*buffer_id)%(control_id+buffer_id);
	fconf.name = "Control_flow";
	Control_flow = NewFlow(control_id, buffer_id, fconf);
	if (Control_flow<0) UnrecoveryError("Could not create flow with Randomizer");
	WriteLog(logCMFile, "Controlflow: OK\n");
	time_slot=0;
	count=0;
	var=0;

	control.mod=BPSK;
	control.mode=0;

}		

/*************************************************************
STOP
************************************************************/	
void CONTROL_Stop() {
		
	DeleteFlow(Control_flow);
	WriteLog(logCMFile, "DeleteFlow Control_flow\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(control_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void CONTROL_Run(){
	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,p,mode;
//	c2buffer control;	

	///DECIDIM LA MODULACIO

	//DEPENENT DE LA MODULACIO omplim la resta de camps.

	switch (control.mod)
	{
		case BPSK:
			if (control.mode==0)
			{
				WriteLog(logCMFile, "BPSK\n");
				control.bits2read=11*8;
				control.rsolomon=0;
				control.cconv=0.5;
				control.interl=192;
				control.mod=1;
				control.mode=0;
				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500) //11300
				{
					control.es_ovr_n0+=1.0;
					count=1;
					var++;
				}
				count++;
				if (var==15)
				{
					control.mod=QPSK;
					control.mode=0;
					count=0;
					var=0;
				}
			}
			break;			
		case QPSK:
			if (control.mode==0)
			{
				control.bits2read=23*8;
				control.rsolomon=8;
				control.cconv=0.6;
				control.interl=384;
				control.mod=2;
				control.mode=0;
				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500) //5400
				{
					control.es_ovr_n0+=1.0;
					count=1;
					var++;
				}
				count++;
				if (var==15)
				{
					control.mod=QPSK;
					control.mode=1;
					count=0;
					var=0;
				}


			}
			else if (control.mode==1)
			{
				control.bits2read=35*8;
				control.rsolomon=4;
				control.cconv=0.8;
				control.interl=384;
				control.mod=2;
				control.mode=1;

				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500) //3500
				{
					control.es_ovr_n0+=1.0;
					count=1;
					var++;
				}
				count++;
				if (var==15)
				{
					control.mod=_16QAM;
					control.mode=0;
					count=0;
					var=0;
				}

			}
			break;

		case _16QAM:
			if (control.mode==0)
			{
				control.bits2read=47*8;
				control.rsolomon=16;
				control.cconv=0.6;
				control.interl=768;
				control.mod=4;
				control.mode=0;

				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500) //2650
				{
					control.es_ovr_n0+=2.0;
					count=1;
					var++;
				}
				count++;
				if (var==15)
				{
					control.mod=_16QAM;
					control.mode=1;
					count=0;
					var=0;
				}

			}
			else if (control.mode==1)
			{
				control.bits2read=71*8;
				control.rsolomon=8;
				control.cconv=0.8;
				control.interl=768;
				control.mod=4;
				control.mode=1;

				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500) //1750
				{
					control.es_ovr_n0+=2.0;
					count=1;
					var++;
				}
				count++;
				if (var==15)
				{
					control.mod=_64QAM;
					control.mode=0;
					count=0;
					var=0;
				}

			}
			break;
			
		case _64QAM:
			if (control.mode==0)
			{
				control.bits2read=95*8;
				control.rsolomon=12;
				control.cconv=0.7;
				control.interl=1152;
				control.mod=6;
				control.mode=0;

				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500)//1310
				{
					control.es_ovr_n0+=2.0;
					count=1;
					var++;
				}
				count++;
				if (var==15)
				{
					control.mod=_64QAM;
					control.mode=1;
					count=0;
					var=0;
				}
			
			}
			else if (control.mode==1)
			{
				control.bits2read=107*8;
				control.rsolomon=12;
				control.cconv=0.8;
				control.interl=1152;
				control.mod=6;
				control.mode=1;
			
				if(count==0)
					control.es_ovr_n0=0.0; // Es/N0
				if (count==1500)//1168
				{
					control.es_ovr_n0+=2.0;
					count=1;
					var++;
				}
				count++;

				if (var==15)
				{
				/*	control.mod=BPSK;
					control.mode=0;
					count=0;
					var=0;
				*/exit(0);
				}
			}
			break;
	}


	if(GetFlowStatus(Control_flow))
	{

//		sprintf(log_msg,"timeslot, %d p=%d",time_slot,p);
//		WriteLog(logCMFile, log_msg);

		n=WriteFlow(Control_flow,sizeof(control),&control);

		if(n<0)
			WriteLog(logCMFile, "Error  writing the flow");
	
		WriteLog(logCMFile, "Flow written\n");
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Control time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}
