#include "cyclic_cm.h"

int main(int argc, char **argv)
{
  	int n=0;
	int c;
    
	printf("CYCLIC module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		cyclic_id=atoi(optarg);
			printf("Cyclic id: %d\n",cyclic_id);
        	break;
		case 's':
        		ifft_id=atoi(optarg);
			printf("Ifft id: %d\n",ifft_id);
        	break;
		case 'd':
        		channelFFT_id=atoi(optarg);
			printf("Decoder id: %d\n",channelFFT_id);
	
        	break;		
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (cyclic_id<0 || ifft_id<0 || channelFFT_id<0)
	{
		printf("Need two mandatory parameter: -m <cyclic_id> -s <ifft_id> -d <channelFFT_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"CYCLIC");
	n=InitCommManagerN(cyclic_id,modulename);
	if(n<0) return(-1);

	printf("Register module CYCLIC: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			CYCLIC_Init();
			CYCLIC_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 CYCLIC_Stat_Run0();
			 CYCLIC_Run();
			 CYCLIC_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 CYCLIC_Stop();
			 CYCLIC_Stat_Stop();
		}
	}
	return(1);
}
