#include "decyclic_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("DECYCLIC  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		decyclic_id=atoi(optarg);
			printf("Decyclic id: %d\n",decyclic_id);
        	break;
		case 's':
        		channelFFT_id=atoi(optarg);
			printf("ChannelFFT id: %d\n",channelFFT_id);
        	break;		
		case 'd':
        		fft_id=atoi(optarg);
			printf("Fft id: %d\n",fft_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (decyclic_id<0 || channelFFT_id<0 || fft_id<0)
	{
		printf("Need two mandatory parameter: -m <decyclic_id> -s <channelFFT_id> -d <fft_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"DECYCLIC");
	n=InitCommManagerN(decyclic_id,modulename);
	if(n<0) return(-1);


	printf("Register module DECYCLIC: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			DECYCLIC_Init();
			DECYCLIC_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 DECYCLIC_Stat_Run0();
			 DECYCLIC_Run();
			 DECYCLIC_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 DECYCLIC_Stop();
			 DECYCLIC_Stat_Stop();
		}
	}

	return(1);

}
