#include "deinter_cm.h"


void deinter (int Ncbps, int Ncpc, int in[], int out[])
{
	int j, mj, kj, s;

	s = ceil (((double)Ncpc)/2);
//	printf("s=%d\n",s);

//	for (j=0; j<Ncbps; j++)
//		printf("[%d]=%d\n",j,in[j]);


	for (j=0; j<Ncbps; j++)
	{
		
		mj=(s*floor((double)(j/s)))+fmod((j+floor((double)(12*j/Ncbps))),s);
//		printf("[%d]mk=%d\n",j,mj);

		kj= 12*mj-((Ncbps-1)*floor((double)(12*mj/Ncbps)));
//		printf("[%d]kj=%d\n",j,kj);

		out[kj]=in[j];
//		printf("out[%d]=in[%d]\n",kj,j);

	}

//	for (j=0; j<Ncbps; j++)
//		printf("[%d]=%d\n",j,out[j]);

}


/**********************************************************
INIT
**********************************************************/
void DEINTER_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create DeInterflow_rx\n");
	//Create DEINTERflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1600;
	fconf.magic = (calsoft_id*deinter_id)%(calsoft_id+deinter_id);
	fconf.name = "DeInter_flow_rx";
	DeInter_flow_rx = NewFlow(deinter_id, calsoft_id, fconf);
	if (DeInter_flow_rx<0) UnrecoveryError("Could not create flow with Cconv");
	WriteLog(logCMFile, "DeInterflow_rx: OK\n");

	WriteLog(logCMFile, "Create DeInterflow_tx\n");
	//Create DeInterflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1600;
	fconf2.magic = (deinter_id*depunc_id)%(deinter_id+depunc_id);
	fconf2.name = "DeInter_flow_tx";
	DeInter_flow_tx = NewFlow(deinter_id, depunc_id, fconf2);
	if (DeInter_flow_tx<0) UnrecoveryError("Could not create flow with DeInterleaving");
	WriteLog(logCMFile, "DeInterflow_tx: OK\n");


}		

/*************************************************************
STOP
************************************************************/	
void DEINTER_Stop() {
		
	DeleteFlow(DeInter_flow_rx);
	WriteLog(logCMFile, "DeleteFlow DeInter_flow_rx\n");


	DeleteFlow(DeInter_flow_tx);
	WriteLog(logCMFile, "DeleteFlow DeInter_flow_tx\n");


	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(deinter_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void DEINTER_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");

	int n,i;
	calsoft2deinter flow_rx;
	deinter2depunc flow_tx;
	int info_in[1152];
	int info_out[1152];
	int len=0;
	
	if(GetFlowStatus(DeInter_flow_rx))
	{

//		WriteLog(logCMFile, "Abans de Llegir");	

		n=ReadFlow(DeInter_flow_rx,sizeof(flow_rx),&flow_rx);
 		if(n>0)
		{
//			sprintf(log_msg,"bytesllegits= %d", n);
//			WriteLog(logCMFile, log_msg);	

			//abans del DeIntertleaving
/*			WriteLog(logCMFile, "Abans DeInterleaving bytes");
			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/
			
			char2int(flow_rx.info,flow_rx.length, info_in);
			
///*
/*			WriteLog(logCMFile, "Abans DeInterleaving bits");
			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_in[i]);
				WriteLog(logCMFile,log_msg);
			}
//*/

			deinter(flow_rx.length,flow_rx.mod,info_in,info_out);
			flow_tx.length=flow_rx.length;
			
///*
/*			WriteLog(logCMFile, "Despres DeInterleaving bits");
			for (i=0; i<flow_tx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_out[i]);
				WriteLog(logCMFile,log_msg);
			}
//*/
			
			int2char(info_out,flow_tx.length,flow_tx.info);			

/*			WriteLog(logCMFile, "Despres DeInterleaving bytes");
			for (i=0; i<flow_tx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/

			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
			flow_tx.cconv=flow_rx.cconv;	

			
			if(GetFlowStatus(DeInter_flow_tx))
			{
				n=WriteFlow(DeInter_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
			      
		}
		else
		{
//			sprintf(log_msg,"mal llegit, %d ",n);
//			WriteLog(logCMFile, log_msg);

               		WriteLog(logCMFile, "Error  writing the flow");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Deinter time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);	

	Relinquish(1);
}
