#include "depilot_cm.h"


/**********************************************************
INIT
**********************************************************/
void DEPILOT_Init()
{
  struct flow_config fconf,fconf2,fconf3;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create depilotflow_rx\n");
	//Create depilotflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 3600;
	fconf.magic = (fft_id*depilot_id)%(fft_id+depilot_id);
	fconf.name = "Depilot_flow_rx";
	Depilot_flow_rx = NewFlow(depilot_id, fft_id, fconf);
	if (Depilot_flow_rx<0) UnrecoveryError("Could not create flow with Fft");
	WriteLog(logCMFile, "Depilotflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Ifftflow_tx\n");
	//Create depilotflow_tx
	
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1600;
	fconf2.magic = (depilot_id*calsoft_id)%(depilot_id+calsoft_id);
	fconf2.name = "Depilot_flow_tx";
	Depilot_flow_tx = NewFlow(depilot_id, calsoft_id, fconf2);
	if (Depilot_flow_tx<0) UnrecoveryError("Could not create flow with Calsoft");
	WriteLog(logCMFile, "Depilotflow_tx: OK\n");

	//Create depilotflow_tx2
/*	
	fconf3.rw = FLOW_READ_WRITE;
	fconf3.type = 0;
	fconf3.options = 0;
	fconf3.max_size = 3600;
	fconf3.magic = (depilot_id*estadisticas_id)%(depilot_id+estadisticas_id);
	fconf3.name = "Depilot_flow_tx2";
	Depilot_flow_tx2 = NewFlow(depilot_id, estadisticas_id, fconf3);
	if (Depilot_flow_tx2<0) UnrecoveryError("Could not create flow with Calsoft");
	WriteLog(logCMFile, "Depilotflow_tx2: OK\n");
*/	
	time_slot=0; 
	}		

/*************************************************************
STOP
************************************************************/	
void DEPILOT_Stop() {
		
	DeleteFlow(Depilot_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Depilot_flow_rx\n");

	DeleteFlow(Depilot_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Depilot_flow_tx\n");

	DeleteFlow(Depilot_flow_tx2);
	WriteLog(logCMFile, "DeleteFlow Depilot_flow_tx2\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(depilot_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void DEPILOT_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;
	fft2depilot flow_rx;
	depilot2calsoft flow_tx;
	depilot2estadisticas flow_tx2;
	float real[256], imag[256];
	symbol dessymbol_ofdm[192];
	//char prueba[50];
	




	if(GetFlowStatus(Depilot_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Depilot_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);
		
		sprintf(log_msg,"read bytes:%d",n);
		WriteLog(logCMFile, log_msg);

		if (n>0)
		{

		
		for (i=0;i<256;i++){
			real[i]=flow_rx.asymbol[i].re;
			imag[i]=flow_rx.asymbol[i].im;
		}

		for(i=0;i<192;i++){
		dessymbol_ofdm[i].re=real[i];
		dessymbol_ofdm[i].im=imag[i];

		//printf("real[%d]:%f",i,dessymbol_ofdm[i].re);
		//printf("imag[%d]:%f",i,dessymbol_ofdm[i].im);
		}

		
		flow_tx.mod=flow_rx.mod;
		flow_tx.mode=flow_rx.mode;
		flow_tx.rsolomon=flow_rx.rsolomon;
		flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
		flow_tx.cconv=flow_rx.cconv;
		flow_tx.num_tx=flow_rx.num_tx;
		flow_tx2.num_tx=flow_rx.num_tx;		
		for (i=0;i<192;i++){
			flow_tx.asymbol[i].re=real[i];
			flow_tx.asymbol[i].im=imag[i];
			flow_tx2.asymbol[i].re=real[i];
			flow_tx2.asymbol[i].im=imag[i];
		}
		if(GetFlowStatus(Depilot_flow_tx))
			
			{
				n=WriteFlow(Depilot_flow_tx,sizeof(flow_tx),&flow_tx);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
		/*
		if(GetFlowStatus(Depilot_flow_tx2))
			
			{
				n=WriteFlow(Depilot_flow_tx2,sizeof(flow_tx2),&flow_tx2);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow2");
			}
		*/
		}
		
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Depilot time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

