#include "depunc_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("DEPUNC  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		depunc_id=atoi(optarg);
			printf("depunc id: %d\n",depunc_id);
        	break;
		case 's':
        		deinter_id=atoi(optarg);
			printf("deinter id: %d\n",deinter_id);
        	break;		
		case 'd':
        		viterbi_id=atoi(optarg);
			printf("Viterbi id: %d\n",viterbi_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (deinter_id<0 || depunc_id<0 || viterbi_id<0)
	{
		printf("Need two mandatory parameter: -m <depunc_id> -s <deinter_id> -d <viterbi_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"DEPUNC");
	n=InitCommManagerN(depunc_id,modulename);
	if(n<0) return(-1);


	printf("Register module DEPUNC: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			 DEPUNC_Init();
			 DEPUNC_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 DEPUNC_Stat_Run0();
			 DEPUNC_Run();
			 DEPUNC_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 DEPUNC_Stop();
			 DEPUNC_Stat_Stop();
		}
	}

	return(1);

}
