#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>


#define K_LENGTH 239 // Gràndaria del msg (sense padding) 
#define N_LENGTH 255

#define NPAR (N_LENGTH-K_LENGTH)
#define MAXDEG (NPAR*2)

#define TRUE 1
#define FALSE 0

typedef unsigned long BIT32;
typedef unsigned short BIT16;

/* Decoder syndrome bytes */
int synBytes[MAXDEG];

/* generator polynomial */
int genPoly[MAXDEG*2];
int pBytes[MAXDEG];

/* The Error Locator Polynomial, also known as Lambda or Sigma. Lambda[0] == 1 */
static int Lambda[MAXDEG];

/* The Error Evaluator Polynomial */
static int Omega[MAXDEG];

/* error locations found using Chien's search*/
static int ErrorLocs[256];
static int NErrors;

/* erasure flags */
static int ErasureLocs[256];
static int NErasures;

int gexp[512];
int glog[256];

void init_exp_table (void);
int gmult(int a, int b);
int ginv (int elt);
void mult_polys (int dst[], int p1[], int p2[]);
void copy_poly (int dst[], int src[]);
void zero_poly (int poly[]); 
void add_polys (int dst[], int src[]); 
static void mul_z_poly (int src[]);
void scale_poly (int k, int poly[]); 
void compute_genpoly (int nbytes, int genpoly[]);
void compute_modified_omega ();
void init_gamma (int gamma[]);
void decode_data(unsigned char data[], int nbytes);
int check_syndrome (void);
void Modified_Berlekamp_Massey (void);
int compute_discrepancy (int lambda[], int S[], int L, int n);
void compute_next_omega (int d, int A[], int dst[], int src[]);
void Find_Roots (void);
int correct_errors_erasures (unsigned char codeword[],  int csize, int nerasures, int erasures[]);
void fill_erasures(int *n, int array[], int bytered);
void fillcodeword (unsigned char msg[], int len, int red, unsigned char code []);
int removepadding(unsigned char code[], unsigned char word[], int len, int red);

