#include "fft_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("FFT  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		fft_id=atoi(optarg);
			printf("Fft id: %d\n",fft_id);
        	break;
		case 's':
        		decyclic_id=atoi(optarg);
			printf("Decyclic id: %d\n",decyclic_id);
        	break;		
		case 'd':
        		depilot_id=atoi(optarg);
			printf("Depilot id: %d\n",depilot_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (depilot_id<0 || fft_id<0 || decyclic_id<0)
	{
		printf("Need two mandatory parameter: -m <fft_id> -s <decyclic_id> -d <depilot_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"FFT");
	n=InitCommManagerN(fft_id,modulename);
	if(n<0) return(-1);


	printf("Register module IFFT: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			 FFT_Init();
			 FFT_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			FFT_Stat_Run0();
			FFT_Run();
			FFT_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 FFT_Stop();
			 FFT_Stat_Stop();
		}
	}

	return(1);

}
