#include "ifft_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("IFFT  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		ifft_id=atoi(optarg);
			printf("Ifft id: %d\n",ifft_id);
        	break;
		case 's':
        		pilot_id=atoi(optarg);
			printf("Pilot id: %d\n",pilot_id);
        	break;		
		case 'd':
        		cyclic_id=atoi(optarg);
			printf("Decoder id: %d\n",cyclic_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (pilot_id<0 || ifft_id<0 || cyclic_id<0)
	{
		printf("Need two mandatory parameter: -m <ifft_id> -s <pilot_id> -d <cyclic_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"IFFT");
	n=InitCommManagerN(ifft_id,modulename);
	if(n<0) return(-1);


	printf("Register module IFFT: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			IFFT_Init();
			IFFT_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			IFFT_Stat_Run0();
			IFFT_Run();
			IFFT_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			IFFT_Stop();
			IFFT_Stat_Stop();
		}
	}

	return(1);

}
