#include "ifft_cm.h"


/**********************************************************
INIT
**********************************************************/
void IFFT_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Channelflow_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 3600;
	fconf.magic = (pilot_id*ifft_id)%(pilot_id+ifft_id);
	fconf.name = "Ifft_flow_rx";
	Ifft_flow_rx = NewFlow(ifft_id, pilot_id, fconf);
	if (Ifft_flow_rx<0) UnrecoveryError("Could not create flow with Pilot");
	WriteLog(logCMFile, "Ifftflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Ifftflow_tx\n");
	//Create Ifftflow_tx
	
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3600;
	fconf2.magic = (ifft_id*cyclic_id)%(ifft_id+cyclic_id);
	fconf2.name = "Ifft_flow_tx";
	Ifft_flow_tx = NewFlow(ifft_id, cyclic_id, fconf2);
	if (Ifft_flow_tx<0) UnrecoveryError("Could not create flow with Cyclic");
	WriteLog(logCMFile, "Ifftflow_tx: OK\n");
	
	time_slot=0; 
	}		

/*************************************************************
STOP
************************************************************/	
void IFFT_Stop() {
		
	DeleteFlow(Ifft_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Ifft_flow_rx\n");

	DeleteFlow(Ifft_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Ifft_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(ifft_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void IFFT_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i,salidaFFT;
	pilot2ifft flow_rx;
	ifft2cyclic flow_tx;
	float real[256], imag[256];
	




	if(GetFlowStatus(Ifft_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Ifft_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);

		if (n>0)
		{


		
		/*printf("antes del for\n");
			for (i=0; i<256; i++)
			{
				printf("real [%d]: %f\n",i,flow_rx.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

				printf("imag [%d]: %f\n",i,flow_rx.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);

			}*/
		
		for (i=0;i<256;i++){
			real[i]=flow_rx.asymbol[i].re;
			imag[i]=flow_rx.asymbol[i].im;
		}
		//printf("antes de FFT\n");
		salidaFFT=FFT(1,8,real,imag);
		//printf("despues de FFT: %d\n",salidaFFT);
		
		flow_tx.mod=flow_rx.mod;
		flow_tx.mode=flow_rx.mode;
		flow_tx.rsolomon=flow_rx.rsolomon;
		flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
		flow_tx.cconv=flow_rx.cconv;
		flow_tx.num_tx=flow_rx.num_tx;
		for (i=0;i<256;i++){
			flow_tx.asymbol[i].re=real[i];
			flow_tx.asymbol[i].im=imag[i];
		}
		if(GetFlowStatus(Ifft_flow_tx))
			
			{
				n=WriteFlow(Ifft_flow_tx,sizeof(flow_tx),&flow_tx);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}


		}
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Ifft time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

