#include "inter_cm.h"

void interleaving(int Ncbps, int Ncpc, int in[], int out[])
{
	int k, mk, jk, s,j;
	
	s = ceil (((double)Ncpc)/2);
//	printf("s=%d\n",s);

//        for (j=0; j<Ncbps; j++)
//		printf("[%d]=%d\n",j,in[j]);
               


	for (k=0; k<Ncbps; k++)
	{	
		mk=(Ncbps/12)*(fmod (k,12)) + floor(((double)k/12));
//		printf("[%d]mk=%d\n",k,mk);

		jk=(s*floor ((double)(mk/s)))+ fmod (mk + Ncbps - floor ((double)(12*mk/Ncbps)),s);
		
//		printf("[%d]jk=%d\n",k,jk);

		out[jk]=in[k];

//		printf("out[%d]=in[%d]\n",jk,k);

	}
	
	
//      for (j=0; j<Ncbps; j++)
//		printf("[%d]=%d\n",j,out[j]);
               

}

/**********************************************************
INIT
**********************************************************/
void INTER_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Interflow_rx\n");
	//Create INTERflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (cconv_id*inter_id)%(cconv_id+inter_id);
	fconf.name = "Inter_flow_rx";
	Inter_flow_rx = NewFlow(inter_id, cconv_id, fconf);
	if (Inter_flow_rx<0) UnrecoveryError("Could not create flow with Cconv");
	WriteLog(logCMFile, "Interflow_rx: OK\n");

	WriteLog(logCMFile, "Create Interflow_tx\n");
	//Create Interflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1500;
	fconf2.magic = (inter_id*smap_id)%(inter_id+smap_id);
	fconf2.name = "Inter_flow_tx";
	Inter_flow_tx = NewFlow(inter_id, smap_id, fconf2);
	if (Inter_flow_tx<0) UnrecoveryError("Could not create flow with Interleaving");
	WriteLog(logCMFile, "Interflow_tx: OK\n");


}		

/*************************************************************
STOP
************************************************************/	
void INTER_Stop() {
		
	DeleteFlow(Inter_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Inter_flow_rx\n");


	DeleteFlow(Inter_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Inter_flow_tx\n");


	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(inter_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void INTER_Run(){
	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;
	cconv2inter flow_rx;
	inter2smap flow_tx;
	int info_in[1152];
	int info_out[1152];

	
	if(GetFlowStatus(Inter_flow_rx))
	{
		n=ReadFlow(Inter_flow_rx,sizeof(flow_rx),&flow_rx);
 		if(n>0)
		{
//			sprintf(log_msg,"timeslot, %d p=%d",time_slot,n);
//			WriteLog(logCMFile, log_msg);

/*
			//Before Intertleaving
			WriteLog(logCMFile, "before Interleaving bytes");
			for (i=0; i<flow_rx.interl/8; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
				WriteLog(logCMFile,log_msg);
			}
*/
			char2bin (info_in,flow_rx.info,flow_rx.interl/8);

///*
/*			WriteLog(logCMFile, "before Interleaving bits");
			for (i=0; i<flow_rx.interl; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_in[i]);
				WriteLog(logCMFile,log_msg);
			}
//*/

			interleaving (flow_rx.interl, flow_rx.mod, info_in, info_out);

/*			WriteLog(logCMFile, "After Interleaving bits");
			for (i=0; i<flow_rx.interl; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_out[i]);
				WriteLog(logCMFile,log_msg);
			}

*/
			bin2char (info_out, flow_tx.info, flow_rx.interl);


/*			WriteLog(logCMFile, "After Interleaving bytes");
			for (i=0; i<flow_rx.interl/8; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/

			flow_tx.length=(flow_rx.interl/8);
			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
			flow_tx.cconv=flow_rx.cconv;

					
			if(GetFlowStatus(Inter_flow_tx))
			{
				n=WriteFlow(Inter_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
			      
		}
		else
		{
			WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Inter time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}
