#include "calsoft_cm.h"


/**********************************************************
INIT
**********************************************************/
void CALSOFT_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Calsoft_flow_rx\n");
	//Create Calsoftflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1600;
	fconf.magic = (calsoft_id*depilot_id)%(calsoft_id+depilot_id);
	fconf.name = "Calsoft_flow_rx";
	Calsoft_flow_rx = NewFlow(calsoft_id, depilot_id, fconf);
	if (Calsoft_flow_rx<0) UnrecoveryError("Could not create flow with Calsoft");
	WriteLog(logCMFile, "Calsoftflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Calsoft_flow_tx\n");
	//Create Calsoftflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1600;
	fconf2.magic = (calsoft_id*deinter_id)%(calsoft_id+deinter_id);
	fconf2.name = "Calsoft_flow_tx";
	Calsoft_flow_tx = NewFlow(calsoft_id, deinter_id, fconf2);
	if (Calsoft_flow_tx<0) UnrecoveryError("Could not create flow with Deinter");
	WriteLog(logCMFile, "Calsoft_flow_tx: OK\n");

	}		

/*************************************************************
STOP
************************************************************/	
void CALSOFT_Stop() {
		
	DeleteFlow(Calsoft_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Calsoft_flow_rx\n");

	DeleteFlow(Calsoft_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Calsoft_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(calsoft_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void CALSOFT_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");

	int n,i;
	depilot2calsoft flow_rx;
	calsoft2deinter flow_tx;
	flow_tx.length=0;
	int info_out[1152];
//	char info_outchar[1152];


	if(GetFlowStatus(Calsoft_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Calsoft_flow_rx,sizeof(flow_rx),&flow_rx);
//		sprintf(log_msg,"read bytes:%d",n);
//		WriteLog(logCMFile, log_msg);
		if (n>0)
		{
///*
			WriteLog(logCMFile, "Before Soft Calculation");
			/*for (i=0; i<192; i++)
			{
				printf("real [%d]:%f\n",i,flow_rx.asymbol[i].re);
				WriteLog(logCMFile,log_msg);

				printf("imag [%d]:%f\n",i,flow_rx.asymbol[i].im);
				WriteLog(logCMFile,log_msg);

			}*/

			calculsoft(flow_rx.es_ovr_n0, flow_rx.mod,192,flow_rx.asymbol, &flow_tx.length, info_out);
				
			int2char(info_out,flow_tx.length,flow_tx.info);

///*
/*			for (i=0; i<flow_tx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile,log_msg);

			}
//*/
			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.cconv=flow_rx.cconv;

	
		

			if(GetFlowStatus(Calsoft_flow_tx))
			{
				n=WriteFlow(Calsoft_flow_tx,sizeof(flow_tx),&flow_tx);
//				sprintf(log_msg,"escrit [%d]",n);
//				WriteLog(logCMFile,log_msg);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
		}
		else
		{
//			sprintf(log_msg,"mal llegit, %d ",n);
//			WriteLog(logCMFile, log_msg);

			WriteLog(logCMFile, "Error  writing the flow");
		}
	}
	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Calsoft time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);

}
