#include "cconv_cm.h"

int main(int argc, char **argv)
{

  	int p=0;
	int c;
    
	printf("CCONV  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		cconv_id=atoi(optarg);
			printf("Cconv id: %d\n",cconv_id);
        	break;
		case 's':
        		rsol_id=atoi(optarg);
			printf("RSol id: %d\n",rsol_id);
        	break;		
		case 'd':
        		inter_id=atoi(optarg);
			printf("Inter id: %d\n",inter_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (rsol_id<0 || inter_id<0 || cconv_id<0)
	{
		printf("Need two mandatory parameter: -m <cconv_id> -s <rsol_id> -d <inter_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"CCONV");
	p=InitCommManagerN(cconv_id,modulename);
	if(p<0) return(-1);


	printf("Register module CCONV: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			CCONV_Init();
			CCONV_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			CCONV_Stat_Run0();
			CCONV_Run();
			CCONV_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			CCONV_Stop();
			CCONV_Stat_Stop();
		}
	}

	return(1);

}
