#include "cconv_cm.h"
#include "cconv_code.h"

/**********************************************************
INIT
**********************************************************/
void CCONV_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create CCflow\n");
	//Create CCflow
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (rsol_id*cconv_id)%(rsol_id+cconv_id);
	fconf.name = "Cconv_flow_rx";
	Cconv_flow_rx = NewFlow(cconv_id,rsol_id, fconf);
	if (Cconv_flow_rx<0) UnrecoveryError("Could not create flow with Cconv");
	WriteLog(logCMFile, "Cconvflow: OK\n");

	WriteLog(logCMFile, "Create CCflow2\n");
	//Create CCflow2
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1500;
	fconf2.magic = (cconv_id*inter_id)%(cconv_id+inter_id);
	fconf2.name = "Cconv_flow_tx";
	Cconv_flow_tx = NewFlow(cconv_id, inter_id, fconf2);
	if (Cconv_flow_tx<0) UnrecoveryError("Could not create flow with Interleaving");
	WriteLog(logCMFile, "Cconvflow2: OK\n");
	
	time_slot=0;
}		

/*************************************************************
STOP
************************************************************/	
void CCONV_Stop() {
		
	DeleteFlow(Cconv_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Cconv_flow_rx\n");

	DeleteFlow(Cconv_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Cconv_flow_rx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(cconv_id);
	
	exit(0);
}

rsol2cconv flow_rx;
cconv2inter flow_tx;

/****************************************************************
RUN
****************************************************************/
void CCONV_Run(){
	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();


	int p,i;
	int info_in[960];
	int info_out[1152];
	int inlen_bytes;

	
	if(GetFlowStatus(Cconv_flow_rx))
	{
		p=ReadFlow(Cconv_flow_rx,sizeof(flow_rx),&flow_rx);
 		if (p>0)
		{
 			sprintf(log_msg,"timeslot, %d p=%d",time_slot,p);
//			WriteLog(logCMFile, log_msg);

//			WriteLog(logCMFile, "Before convolutional");
/*			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/

			inlen_bytes=char2bin (info_in,flow_rx.info,flow_rx.length);
			
///*
/*			WriteLog(logCMFile, "before convolutional in bits");
			for (i=0; i<inlen_bytes; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_in[i]);
				WriteLog(logCMFile,log_msg);
			}

			sprintf(log_msg,"codificacio %f",flow_rx.cconv);
			WriteLog(logCMFile, log_msg);
//*/
			convolutional(info_in,info_out,flow_rx.cconv*10.0,inlen_bytes);
	
			//Out convolutional bits
/*
			WriteLog(logCMFile, "Out Convolutional in bits");
			for (i=0; i<flow_rx.interl; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_out[i]);
				WriteLog(logCMFile,log_msg);
			}*/
	
			bin2char (info_out, flow_tx.info, flow_rx.interl);


			//Write out Convolucional
/*			WriteLog(logCMFile, "Out Convolutional in bytes");
			for (i=0; i<flow_rx.interl/8; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/

			flow_tx.interl=flow_rx.interl;
			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
			flow_tx.cconv=flow_rx.cconv;
		
			if(GetFlowStatus(Cconv_flow_tx))
			{
				p=WriteFlow(Cconv_flow_tx,sizeof(flow_tx),&flow_tx);
				if(p<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
			

		}
		else      
		{
 	 		WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Cconv time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);


	Relinquish(1);
}


