#include "channelFFT_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("CHANNELFFT  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		channelFFT_id=atoi(optarg);
			printf("ChannelFFT id: %d\n",channelFFT_id);
        	break;
		case 's':
        		cyclic_id=atoi(optarg);
			printf("cyclic id: %d\n",cyclic_id);
        	break;		
		case 'd':
        		decyclic_id=atoi(optarg);
			printf("Decyclic id: %d\n",decyclic_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (channelFFT_id<0 || cyclic_id<0 || decyclic_id<0)
	{
		printf("Need two mandatory parameter: -m <channelFFT_id> -s <cyclic_id> -d <decyclic_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"CHANNELFFT");
	n=InitCommManagerN(channelFFT_id,modulename);
	if(n<0) return(-1);


	printf("Register module CHANNELFFT: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			CHANNELFFT_Init();
			CHANNELFFT_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 CHANNELFFT_Stat_Run0();
			 CHANNELFFT_Run();
			 CHANNELFFT_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			CHANNELFFT_Stat_Stop();
			CHANNELFFT_Stop();
		}
	}

	return(1);

}
