#include "channelFFT_cm.h"


/**********************************************************
INIT
**********************************************************/
void CHANNELFFT_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create ChannelFFTflow_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 3600;
	fconf.magic = (cyclic_id*channelFFT_id)%(cyclic_id+channelFFT_id);
	fconf.name = "ChannelFFT_flow_rx";
	ChannelFFT_flow_rx = NewFlow(channelFFT_id, cyclic_id, fconf);
	if (ChannelFFT_flow_rx<0) UnrecoveryError("Could not create flow with Cyclic");
	WriteLog(logCMFile, "ChannelFFTflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create ChannelFFTflow_tx\n");

	
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3600;
	fconf2.magic = (channelFFT_id*decyclic_id)%(channelFFT_id+decyclic_id);
	fconf2.name = "ChannelFFT_flow_tx";
	ChannelFFT_flow_tx = NewFlow(channelFFT_id, decyclic_id, fconf2);
	if (ChannelFFT_flow_tx<0) UnrecoveryError("Could not create flow with Decyclic");
	WriteLog(logCMFile, "ChannelFFTflow_tx: OK\n");
	
	time_slot=0; 
	}		

/*************************************************************
STOP
************************************************************/	
void CHANNELFFT_Stop() {
		
	DeleteFlow(ChannelFFT_flow_rx);
	WriteLog(logCMFile, "DeleteFlow ChannelFFT_flow_rx\n");

	DeleteFlow(ChannelFFT_flow_tx);
	WriteLog(logCMFile, "DeleteFlow ChannelFFT_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(channelFFT_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void CHANNELFFT_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;
	cyclic2channelFFT flow_rx;
	channelFFT2decyclic flow_tx;
	symbol real[320],imag[320];
	
	if(GetFlowStatus(ChannelFFT_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(ChannelFFT_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);

		sprintf(log_msg,"read bytes:%d",n);
		WriteLog(logCMFile, log_msg);

		if (n>0)
		{



		//Añadir las funciones del canal aqui
		canal(0,flow_rx.asymbol,flow_tx.asymbol,15,1);		


		
		flow_tx.mod=flow_rx.mod;
		flow_tx.mode=flow_rx.mode;
		flow_tx.rsolomon=flow_rx.rsolomon;
		flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
		flow_tx.cconv=flow_rx.cconv;
		flow_tx.num_tx=flow_rx.num_tx;

		/*for(i=0;i<320;i++){
			flow_tx.asymbol[i].re=flow_rx.asymbol[i].re;
			flow_tx.asymbol[i].im=flow_rx.asymbol[i].im;
		}*/


		
		if(GetFlowStatus(ChannelFFT_flow_tx))
			
			{
				n=WriteFlow(ChannelFFT_flow_tx,sizeof(flow_tx),&flow_tx);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}


		}
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}
	

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Ifft time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

