/***************************************************************************
Gestio dels LOGS del RRM
***************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "cm_ifc.h"
#include "logs.h"


/*********************************************
Variables
*********************************************/
int log_level=0; //El parametre es llegeix en la inicialitzacio
int logCMFile=-1; //Fitxer de LOGS del CManager
int log_testbed_status=TB_STOP;

/**** Do not use inside this file !!!! ****/
char log_msg[512];

char log_str1[512];
char log_str[1024];


/**********************************************
Exported Funcions
***********************************************/
void setTestbedStatusForLogs(int status){
	log_testbed_status=status;
}

void setLogLevel (int level){
	log_level=level;
}

void setLogCMFile (int file_id){
	logCMFile=file_id;
}

int getLogCMFile (void){
	return logCMFile;
}


int checkLogLevel(int level){
	if (level<log_level) return 0;
	else return 1;
}

int WriteLogRRM(int log_id, char *string,int level){
	if (level>=log_level) 
		WriteLog(log_id,string);
	else return 0;
	return(1);
}

int WriteMsgRRM(int log_id, int dest, char *short_msg_desc, char *long_msg_desc, int level){
	if (level>=log_level) 
		WriteMsg(log_id, dest, short_msg_desc, long_msg_desc);
	else return 0;
	return(1);
}

int WriteVarRRM(int log_id, char *var_name, char *var_value, int level){

	if (level>=log_level) {
		if (log_testbed_status==TB_INIT)	
		{
			sprintf(log_str,"%s=%s",var_name,var_value);
			WriteLog(log_id, log_str);
		}
		else WriteVar(log_id, var_name, var_value);			
	}
	else return 0;
	
	return(1);
}

int LogStatRRM(int log_id, int stat_id, int idx,int level){
	if (level>=log_level) 
		LogStat(log_id, stat_id, idx);
	else return 0;
	
	return(1);
}

void dump_message(unsigned char *ptr, int size)
{
	int i;
	sprintf(log_str,"Dump Message: ");
	for (i=0;i<size;i++) 
	{
		sprintf(log_str1,"0x%.2x ",ptr[i]);
		strcat(log_str,log_str1);
	}
	//Write to log file
	WriteLog(logCMFile,log_str);
}


