#include "cyclic_cm.h"


/**********************************************************
INIT
**********************************************************/
void CYCLIC_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Channelflow_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 3600;
	fconf.magic = (ifft_id*cyclic_id)%(ifft_id+cyclic_id);
	fconf.name = "Cyclic_flow_rx";
	Cyclic_flow_rx = NewFlow(cyclic_id, ifft_id, fconf);
	if (Cyclic_flow_rx<0) UnrecoveryError("Could not create flow with Cyclic");
	WriteLog(logCMFile, "Cyclicflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Cyclicflow_tx\n");
	//Create Cyclicflow_tx
	
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3600;
	fconf2.magic = (cyclic_id*channelFFT_id)%(cyclic_id+channelFFT_id);
	fconf2.name = "Cyclic_flow_tx";
	Cyclic_flow_tx = NewFlow(cyclic_id, channelFFT_id, fconf2);
	if (Cyclic_flow_tx<0) UnrecoveryError("Could not create flow with Fft");
	WriteLog(logCMFile, "Clyclicflow_tx: OK\n");
	
	time_slot=0; 
	}		

/*************************************************************
STOP
************************************************************/	
void CYCLIC_Stop() {
		
	DeleteFlow(Cyclic_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Cyclic_flow_rx\n");

	DeleteFlow(Cyclic_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Cyclic_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(cyclic_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void CYCLIC_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i,salidaCyclic;
	ifft2cyclic flow_rx;
	cyclic2channelFFT flow_tx;
	float real[400], imag[400];
	


	if(GetFlowStatus(Cyclic_flow_rx))
	{	
		
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Cyclic_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);
		
		sprintf(log_msg,"read bytes:%d",n);
		WriteLog(logCMFile, log_msg);

		if (n>0)
		{


		/*
		
			for (i=0; i<192; i++)
			{
				printf("real [%d]: %f\n",i,flow_rx.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

				printf("imag [%d]: %f\n",i,flow_rx.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);

			}
		//wait(5);*/
			
		for (i=0;i<256;i++){
			real[i]=flow_rx.asymbol[i].re;
			imag[i]=flow_rx.asymbol[i].im;
		}
		
		
		salidaCyclic=cyclic(1,256,real,imag);
		
		
		flow_tx.mod=flow_rx.mod;
		flow_tx.mode=flow_rx.mode;
		flow_tx.rsolomon=flow_rx.rsolomon;
		flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
		flow_tx.cconv=flow_rx.cconv;
		flow_tx.num_tx=flow_rx.num_tx;
		
		for (i=0;i<320;i++){
			flow_tx.asymbol[i].re=real[i];
			flow_tx.asymbol[i].im=imag[i];
		}
		
		if(GetFlowStatus(Cyclic_flow_tx))
			
			{
				n=WriteFlow(Cyclic_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}


		}
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Ifft time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

