#include "depilot_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("DEPILOT  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:e:")) != -1)//d:
		switch(c){
		case 'm':
        		depilot_id=atoi(optarg);
			printf("Depilot id: %d\n",depilot_id);
        	break;
		case 's':
        		fft_id=atoi(optarg);
			printf("Fft id: %d\n",fft_id);
        	break;		
		case 'd':
        		calsoft_id=atoi(optarg);
			printf("Calsoft id: %d\n",calsoft_id);
	
        	break;
		case 'e':
        		estadisticas_id=atoi(optarg);
			printf("Estadisticas id: %d\n",estadisticas_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (depilot_id<0 || fft_id<0 || calsoft_id<0 || estadisticas_id<0)
	{
		printf("Need two mandatory parameter: -m <depilot_id> -s <fft_id> -d <calsoft_id> -e <estadisticas_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"DEPILOT");
	n=InitCommManagerN(depilot_id,modulename);
	if(n<0) return(-1);


	printf("Register module DEPILOT: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			 DEPILOT_Init();
			 DEPILOT_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 DEPILOT_Stat_Run0();
			 DEPILOT_Run();
			 DEPILOT_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) DEPILOT_Stop();
	}

	return(1);

}
