#include "depunc_cm.h"

/**********************************************************
INIT
**********************************************************/
void DEPUNC_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Channelflow_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1600;
	fconf.magic = (deinter_id*depunc_id)%(deinter_id+depunc_id);
	fconf.name = "Depunc_flow_rx";
	Depunc_flow_rx = NewFlow(depunc_id, deinter_id, fconf);
	if (Depunc_flow_rx<0) UnrecoveryError("Could not create flow with Depunc");
	WriteLog(logCMFile, "Depuncflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Depuncflow_tx\n");
	//Create Channelflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 4000;
	fconf2.magic = (depunc_id*viterbi_id)%(depunc_id+viterbi_id);
	fconf2.name = "Depunc_flow_tx";
	Depunc_flow_tx = NewFlow(depunc_id, viterbi_id, fconf2);
	if (Depunc_flow_tx<0) UnrecoveryError("Could not create flow with Viterbi");
	WriteLog(logCMFile, "Depuncflow_tx: OK\n");
	time_slot=0;

}		

/*************************************************************
STOP
************************************************************/	
void DEPUNC_Stop() {
		
	DeleteFlow(Depunc_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Depunc_flow_rx\n");

	DeleteFlow(Depunc_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Depunc_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(depunc_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void DEPUNC_Run(){

	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;
	deinter2depunc flow_rx;
	depunc2viterbi flow_tx;
	int info_in[1152];
	int info_out[1920];
	int len=0;

	if(GetFlowStatus(Depunc_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Depunc_flow_rx,sizeof(flow_rx),&flow_rx);
//		sprintf(log_msg,"read bytes:%d",n);
//		WriteLog(logCMFile, log_msg);
		if (n>0)
		{
/*			WriteLog(logCMFile, "Abans depuncturing char");
			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/
			
			char2int(flow_rx.info,flow_rx.length, info_in);
			
/*			WriteLog(logCMFile, "Abans Depuncturing bits");
			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_in[i]);
				WriteLog(logCMFile,log_msg);
			}*/
				
			depucturing(flow_rx.mod,flow_rx.cconv*10.0, flow_rx.length, info_in, &len, info_out);

/*			WriteLog(logCMFile, "Despres Depuncturing integers");
			for (i=0; i<len; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_out[i]);
				WriteLog(logCMFile,log_msg);
			}*/

			int2char(info_out,len,flow_tx.info);			

/*			WriteLog(logCMFile, "Despres Depuncturing char");
			for (i=0; i<len; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile,log_msg);
			}

			sprintf(log_msg,"length[%d]",len);
			WriteLog(logCMFile,log_msg);
*/
			flow_tx.length=len;
			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;


		
			if(GetFlowStatus(Depunc_flow_tx))
			{
				n=WriteFlow(Depunc_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
		
		}
		else
		{
//			sprintf(log_msg,"mal llegit, %d ",n);
//			WriteLog(logCMFile, log_msg);

			WriteLog(logCMFile, "Error  writing the flow");
		}
	}
	
	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Depunc time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);

}



