#include "dersol_cm.h"


int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("RSOL  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		dersol_id=atoi(optarg);
			printf("deRsol id: %d\n",dersol_id);
        	break;
		case 's':
        		viterbi_id=atoi(optarg);
			printf("Viterbi id: %d\n",viterbi_id);
        	break;		
		case 'd':
        		derando_id=atoi(optarg);
			printf("derando id: %d\n",derando_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (viterbi_id<0 || dersol_id<0 || derando_id<0)
	{
		printf("Need two mandatory parameter: -m <dersol_id> -s <viterbi_id> -d <derando_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"DERSOL");
	n=InitCommManagerN(dersol_id,modulename);
	if(n<0) return(-1);


	printf("Register module DERSOL: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			 DERSOL_Init();
			 DERSOL_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 DERSOL_Stat_Run0();
			 DERSOL_Run();
			 DERSOL_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 DERSOL_Stop();
			 DERSOL_Stat_Stop();
		}
	}

	return(1);

}
