#include "dersol_cm.h"
#include "dersol_code.h"


/**********************************************************
INIT
**********************************************************/
void DERSOL_Init()
{
 	struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create deRSolflow\n");
	//Create deRSolflow
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (viterbi_id*dersol_id)%(viterbi_id+dersol_id);
	fconf.name = "deRSol_flow_rx";
	deRSol_flow_rx = NewFlow(dersol_id, viterbi_id, fconf);
	if (deRSol_flow_rx<0) UnrecoveryError("Could not create flow with deRSol");
	WriteLog(logCMFile, "deRSolflow_rx: OK\n");

	WriteLog(logCMFile, "Create deRSolflow2\n");
	//Create deRSolflow2
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 2000;
	fconf2.magic = (dersol_id*derando_id)%(dersol_id+derando_id);
	fconf2.name = "deRSol_flow_tx";
	deRSol_flow_tx = NewFlow(dersol_id, derando_id, fconf2);
	if (deRSol_flow_tx<0) UnrecoveryError("Could not create flow with Cconv");
	WriteLog(logCMFile, "deRSolflow_tx: OK\n");
	time_slot=0;

	init_exp_table();	//inicialitzam lookup tables GF(2^8)
	compute_genpoly (NPAR, genPoly); //Calculam el Polinomi generador

}

/*************************************************************
STOP
************************************************************/
void DERSOL_Stop() {

	DeleteFlow(deRSol_flow_rx);
	WriteLog(logCMFile, "DeleteFlow deRSol_flow_rx\n");

	DeleteFlow(deRSol_flow_tx);
	WriteLog(logCMFile, "DeleteFlow deRSol_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(dersol_id);

	exit(0);
}
viterbi2dersol flow_rx;
dersol2derando flow_tx;

time_t t[3];

/****************************************************************
RUN
****************************************************************/
void DERSOL_Run(){

	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;

	int erasures[16];
  	int nerasures = 0;

	unsigned char codeword[N_LENGTH];

	if(GetFlowStatus(deRSol_flow_rx))
	{
		n=ReadFlow(deRSol_flow_rx,sizeof(flow_rx),&flow_rx);
		if(n>0)
		{

//			sprintf(log_msg,"timeslot, %d p=%d",time_slot,n);
//			WriteLog(logCMFile, log_msg);

//			sprintf(log_msg,"dersolomon %d",flow_rx.rsolomon);
//			WriteLog(logCMFile, log_msg);

			if (flow_rx.mod!=1){	//per modulació BPSK bypass del RS
//
/*				//Mostra msg
				sprintf(log_msg,"Msg_bytes sense 0's");
				WriteLog(logCMFile, log_msg);
				for (i=0; i<flow_rx.length; i++){
					sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
					WriteLog(logCMFile,log_msg);
				}*/

				fill_erasures(&nerasures, erasures,(16-flow_rx.rsolomon));

				fillcodeword(flow_rx.info,flow_rx.length,flow_rx.rsolomon,codeword); //monta el codeword


				//Mostra msg
/*				sprintf(log_msg,"Codeword with padding");
				WriteLog(logCMFile, log_msg);
				for (i=0; i<N_LENGTH; i++){
					sprintf(log_msg,"[%d]%d",i,codeword[i]);
					WriteLog(logCMFile,log_msg);
				}*/

				decode_data(codeword, N_LENGTH);

				if (check_syndrome () != 0) {
					correct_errors_erasures (codeword, N_LENGTH, nerasures, erasures);
				}




				//Mostra msg
/*				sprintf(log_msg,"Codeword with padding");
				WriteLog(logCMFile, log_msg);
				for (i=0; i<K_LENGTH; i++){
					sprintf(log_msg,"[%d]%d",i,codeword[i]);
					WriteLog(logCMFile,log_msg);
				}*/


				flow_tx.length=removepadding(codeword, flow_tx.info, flow_rx.length, flow_rx.rsolomon);
				//Mostra Codeword
/*				sprintf(log_msg,"Codeword");
				WriteLog(logCMFile, log_msg);
				for (i=0; i<flow_tx.length; i++){
					sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
					WriteLog(logCMFile,log_msg);
				}*/


//				sprintf(log_msg,"flow_txlength=%d",flow_tx.length);
//				WriteLog(logCMFile,log_msg);
			}
			else
			{
				//If the modulation used is BPSK, the info in is copied to the info out
				for (i=0; i< flow_rx.length-1; i++)
				{
					flow_tx.info[i]=flow_rx.info[i];
				}
				flow_tx.length=flow_rx.length-1;
			}

			flow_tx.mode=flow_rx.mode;
		//	printf("mode=%d\n",flow_tx.mode);
			flow_tx.mod=flow_rx.mod;
		//	printf("mod=%d\n",flow_tx.mod);

			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;

/*			for (i=0; i<flow_tx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile, log_msg);
			}*/


			if(GetFlowStatus(deRSol_flow_tx))
			{
				n=WriteFlow(deRSol_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}

		}
 		else
		{
//			sprintf(log_msg,"mal llegit, %d ",n);
//			WriteLog(logCMFile, log_msg);

			WriteLog(logCMFile, "Error  writing the flow");
		}
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Dersol time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}
