#include "fft_cm.h"


/**********************************************************
INIT
**********************************************************/
void FFT_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Fftflow_rx\n");
	//Create fftflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 3600;
	fconf.magic = (decyclic_id*fft_id)%(decyclic_id+fft_id);
	fconf.name = "Fft_flow_rx";
	Fft_flow_rx = NewFlow(fft_id, decyclic_id, fconf);
	if (Fft_flow_rx<0) UnrecoveryError("Could not create flow with decyclic");
	WriteLog(logCMFile, "Fftflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Fftflow_tx\n");
	//Create fftflow_tx
	
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3600;
	fconf2.magic = (fft_id*depilot_id)%(fft_id+depilot_id);
	fconf2.name = "Fft_flow_tx";
	Fft_flow_tx = NewFlow(fft_id, depilot_id, fconf2);
	if (Fft_flow_tx<0) UnrecoveryError("Could not create flow with Depylot");
	WriteLog(logCMFile, "Fftflow_tx: OK\n");
	
	time_slot=0; 
	}		

/*************************************************************
STOP
************************************************************/	
void FFT_Stop() {
		
	DeleteFlow(Fft_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Fft_flow_rx\n");

	DeleteFlow(Fft_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Fft_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(fft_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void FFT_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i,salidaFFT;
	decyclic2fft flow_rx;
	fft2depilot flow_tx;
	float real[256], imag[256];
	




	if(GetFlowStatus(Fft_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Fft_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);
		
		sprintf(log_msg,"read bytes:%d",n);
		WriteLog(logCMFile, log_msg);

		if (n>0)
		{


		
		/*for (i=0; i<256; i++)
			{
				printf("real [%d]: %f\n",i,flow_rx.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

				printf("imag [%d]: %f\n",i,flow_rx.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);

			}*/
		
		for (i=0;i<256;i++){
			real[i]=flow_rx.asymbol[i].re;
			imag[i]=flow_rx.asymbol[i].im;
		}
		//printf("antes de FFT\n");
		salidaFFT=FFT(-1,8,real,imag);
		//printf("despues de FFT: %d\n",salidaFFT);
		
		flow_tx.mod=flow_rx.mod;
		flow_tx.mode=flow_rx.mode;
		flow_tx.rsolomon=flow_rx.rsolomon;
		flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
		flow_tx.cconv=flow_rx.cconv;
		flow_tx.num_tx=flow_rx.num_tx;
		for (i=0;i<256;i++){
			flow_tx.asymbol[i].re=real[i];
			flow_tx.asymbol[i].im=imag[i];
		}
		if(GetFlowStatus(Fft_flow_tx))
			
			{
				n=WriteFlow(Fft_flow_tx,sizeof(flow_tx),&flow_tx);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}


		}
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Ifft time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

