#include "rando_cm.h"


void randomize(int datain[],int dataout[],int length)
{
  int xor1=0,i=0, k=0;

  int arrayinit[15]= {1,0,0,1,0,1,0,1,0,0,0,0,0,0,0};

  for (i=1; i<=length; i++)
    {
      if (arrayinit[13]==arrayinit[14])
	xor1=0;
      else 
	xor1=1; 

      for (k=14;k>=1;k--)
     	arrayinit[k]=arrayinit[k-1];
     
      arrayinit[0]=xor1;
    
      if (datain[i-1]==xor1)
	dataout[i-1]=0;
      else 
    	dataout[i-1]=1;
      
    }
}

/**********************************************************
INIT
**********************************************************/
void RANDO_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Randoflow_rx\n");
	//Create Randoflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (buffer_id*rando_id)%(buffer_id+rando_id);
	fconf.name = "Rando_flow_rx";
	Rando_flow_rx = NewFlow(rando_id, buffer_id, fconf);
	if (Rando_flow_rx<0) UnrecoveryError("Could not create flow with Randomizer");
	WriteLog(logCMFile, "Randoflow_rx: OK\n");
	
	WriteLog(logCMFile, "Create Randoflow_tx\n");
	//Create Randoflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3500;
	fconf2.magic = (rando_id*rsolomon_id)%(rando_id+rsolomon_id);
	fconf2.name = "Rando_flow_tx";
	Rando_flow_tx = NewFlow(rando_id, rsolomon_id, fconf2);
	if (Rando_flow_tx<0) UnrecoveryError("Could not create flow with RSolomon");
	WriteLog(logCMFile, "Randoflow_tx: OK\n");
		time_slot=0;

}		

/*************************************************************
STOP
************************************************************/	
void RANDO_Stop() {
		
	DeleteFlow(Rando_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Rando_flow_rx\n");

	DeleteFlow(Rando_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Rando_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(rando_id);
	
	exit(0);
}





/****************************************************************
RUN
****************************************************************/
void RANDO_Run(){
	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();


  	int n,i;
 	buffer2rand flow_rx;
 	rand2rsolomon flow_tx;
	int info_in[864];
	int info_out[864];


	if(GetFlowStatus(Rando_flow_rx))
	{
  		n=ReadFlow(Rando_flow_rx,sizeof(flow_rx),&flow_rx);
  		if (n>0)
		{	
//			sprintf(log_msg,"timeslot, %d p=%d",time_slot,n);
//			WriteLog(logCMFile, log_msg);

			flow_tx.length=char2bin (info_in,flow_rx.info,flow_rx.length);
	
//			sprintf(log_msg,"length %d", flow_rx.length);
//			WriteLog(logCMFile, log_msg);

			//Rando in in bits
 /*			for (i=0; i<flow_tx.length; i++){
				sprintf(log_msg,"[%d]%d\n",i, info_in[i]);
				WriteLog(logCMFile, log_msg);  
			}
*/
  			randomize(info_in,info_out,flow_tx.length); 
 
			//Rando out in bits
/* 			for (i=0; i<(flow_rx.length*8); i++){
				sprintf(log_msg,"[%d]%d\n",i, info_out[i]);
				WriteLog(logCMFile, log_msg);  
			}
*/
 			flow_tx.length=bin2char (info_out, flow_tx.info, flow_tx.length);

			//Rando out in bytes
/* 			for (i=0; i<flow_rx.length; i++){
				sprintf(log_msg,"[%d]%d\n",i, flow_tx.info[i]);
				WriteLog(logCMFile, log_msg);  
			}
*/
  			flow_tx.rsolomon=flow_rx.rsolomon;
 	 		flow_tx.cconv=flow_rx.cconv;
 			flow_tx.interl=flow_rx.interl;
  			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;		
			if(GetFlowStatus(Rando_flow_tx))
			{
 				n=WriteFlow(Rando_flow_tx,sizeof(flow_tx),&flow_tx);
	 			if(n<0)
  		  			WriteLog(logCMFile, "Error  writing the flow");
			}
		}
  		else
		{

			WriteLog(logCMFile, "There is no flow to read");
		}
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Rando time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

