#include "rsol_cm.h"


int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("RSOL  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		rsol_id=atoi(optarg);
			printf("Rsol id: %d\n",rsol_id);
        	break;
		case 's':
        		rando_id=atoi(optarg);
			printf("Rando id: %d\n",rando_id);
        	break;		
		case 'd':
        		cconv_id=atoi(optarg);
			printf("Cconv id: %d\n",cconv_id);

        	break;

		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (rando_id<0 || rsol_id<0 || cconv_id<0)
	{
		printf("Need two mandatory parameter: -m <rando_id> -s <cconv_id> -d <rsol_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"RSOL");
	n=InitCommManagerN(rsol_id,modulename);
	if(n<0) return(-1);


	printf("Register module RSOL: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			RSOL_Init();
			RSOL_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			RSOL_Stat_Run0();
			RSOL_Run();
			RSOL_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			RSOL_Stop();
			RSOL_Stat_Stop();
		}
	}

	return(1);

}
