#include "smap_cm.h"
int num_tx=0;
/**********************************************************
INIT
**********************************************************/
void SMAP_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Smapflow_rx\n");
	//Create Smapflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (inter_id*smap_id)%(inter_id+smap_id);
	fconf.name = "Smap_flow_rx";
	Smap_flow_rx = NewFlow(smap_id, inter_id, fconf);
	if (Smap_flow_rx<0) UnrecoveryError("Could not create flow with Inter");
	WriteLog(logCMFile, "Smapflow_rx: OK\n");

	WriteLog(logCMFile, "Create Smapflow_tx\n");
	//Create Smapflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1600;
	fconf2.magic = (smap_id*pilot_id)%(smap_id+pilot_id);
	fconf2.name = "Smap_flow_tx";
	Smap_flow_tx = NewFlow(smap_id, pilot_id, fconf2);
	if (Smap_flow_tx<0) UnrecoveryError("Could not create flow with Smapping");
	WriteLog(logCMFile, "Smapflow_tx: OK\n");
	time_slot=0;
}

/*************************************************************
STOP
************************************************************/
void SMAP_Stop() {

	DeleteFlow(Smap_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Smap_flow_rx\n");

	DeleteFlow(Smap_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Smap_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(smap_id);

	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void SMAP_Run(){
	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int i,n;
	inter2smap flow_rx;
	smap2pilot flow_tx;
	int info_in[1152];
	int len;


	if(GetFlowStatus(Smap_flow_rx))
	{
		n=ReadFlow(Smap_flow_rx,sizeof(flow_rx),&flow_rx);
 		if(n>0)
		{
//			sprintf(log_msg,"timeslot, %d p=%d",time_slot,n);
//			WriteLog(logCMFile, log_msg);


			//abans del Symbol Mapping
//			WriteLog(logCMFile, "Abans Smapping bytes");
/*			for (i=0; i<flow_rx.length; i++)//DUda
			{
				sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/



			len=char2bin (info_in,flow_rx.info,flow_rx.length);//¿?
			//sprintf(prueba,"info_in: %d\n",info_in[i]);
			//write (1,prueba,sizeof(prueba));

/*			WriteLog(logCMFile, "Abans SMapping bits");
			for (i=0; i<len; i++)
			{
				sprintf(log_msg,"[%d]%d",i,info_in[i]);
				WriteLog(logCMFile,log_msg);
			}*/


			symbolmap(info_in,len,flow_tx.asymbol,flow_rx.mod);


/*			WriteLog(logCMFile, "Despres SMapping symbols");*/
		/*	for (i=0; i<192; i++)
			{
				sprintf(prueba,"real [%d]:%f\n",i,flow_tx.asymbol[i].re);
				write (1,prueba,sizeof(prueba));

				sprintf(prueba,"imag [%d]:%f\n",i,flow_tx.asymbol[i].im);
				write (1,prueba,sizeof(prueba));

			}*/

			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
			flow_tx.cconv=flow_rx.cconv;
			flow_tx.num_tx=num_tx;
			flow_tx.length=flow_rx.length;
			num_tx++;

			if(GetFlowStatus(Smap_flow_tx))
			{
				n=WriteFlow(Smap_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}


		}
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Smap time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

