#include "viterbi_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("VITERBI  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:")) != -1)//d:
		switch(c){
		case 'm':
        		viterbi_id=atoi(optarg);
			printf("viterbi id: %d\n",viterbi_id);
        	break;
		case 's':
        		depunc_id=atoi(optarg);
			printf("depunc id: %d\n",depunc_id);
        	break;		
		case 'd':
        		dersol_id=atoi(optarg);
			printf("dersol id: %d\n",dersol_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}
	
	if (depunc_id<0 || viterbi_id<0 || dersol_id<0)
	{
		printf("Need two mandatory parameter: -m <viterbi_id> -s <depunc_id> -d <dersol_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"VITERBI");
	n=InitCommManagerN(viterbi_id,modulename);
	if(n<0) return(-1);


	printf("Register module VITERBI: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT)
		{
			 VITERBI_Init();
			 VITERBI_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN)
		{
			 VITERBI_Stat_Run0();
			 VITERBI_Run();
			 VITERBI_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP)
		{
			 VITERBI_Stop();
			 VITERBI_Stat_Stop();
		}
	}

	return(1);

}
