#include "viterbi_cm.h"
#include "viterbi_code.h"

/**********************************************************
INIT
**********************************************************/
void VITERBI_Init()
{
  struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Viterbiflow_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 4000;
	fconf.magic = (viterbi_id*depunc_id)%(viterbi_id+depunc_id);
	fconf.name = "Viterbi_flow_rx";
	Viterbi_flow_rx = NewFlow(viterbi_id, depunc_id, fconf);
	if (Viterbi_flow_rx<0) UnrecoveryError("Could not create flow with Viterbi");
	WriteLog(logCMFile, "Viterbiflow_rx: OK\n");
	

	WriteLog(logCMFile, "Create Viterbiflow_tx\n");
	//Create Viterbiflow_tx
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1500;
	fconf2.magic = (dersol_id*viterbi_id)%(dersol_id+viterbi_id);
	fconf2.name = "Viterbi_flow_tx";
	Viterbi_flow_tx = NewFlow(viterbi_id, dersol_id, fconf2);
	if (Viterbi_flow_tx<0) UnrecoveryError("Could not create flow with Viterbi");
	WriteLog(logCMFile, "Viterbiflow_tx: OK\n");


}		

/*************************************************************
STOP
************************************************************/	
void VITERBI_Stop() {
		
	DeleteFlow(Viterbi_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Viterbi_flow_rx\n");

	DeleteFlow(Viterbi_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Viterbi_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(depunc_id);
	
	exit(0);
}

/****************************************************************
RUN
****************************************************************/
void VITERBI_Run(){

	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;
	depunc2viterbi flow_rx;
	viterbi2dersol flow_tx;
	float info_in[1920];
	int info_out[960];
	int len;
	long super = 204;

	int g[2][K] = {{1,  1, 1, 1,  0, 0, 1},  /* 171 */
                   {1,  0, 1, 1,  0, 1, 1}}; /* 133 */

	if(GetFlowStatus(Viterbi_flow_rx))
	{	
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);
		

		n=ReadFlow(Viterbi_flow_rx,sizeof(flow_rx),&flow_rx);
//		sprintf(log_msg,"read bytes:%d",n);
//		WriteLog(logCMFile, log_msg);
		if (n>0)
		{
//			sprintf(log_msg,"flow_rxlength[%d]",flow_rx.length);
//			WriteLog(logCMFile,log_msg);

/*			WriteLog(logCMFile, "Abans viterbi char");
			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
				WriteLog(logCMFile,log_msg);
			}*/
			
			char2float(flow_rx.info, flow_rx.length, info_in);
			
/*			WriteLog(logCMFile, "Abans Viterbi bits");
			for (i=0; i<flow_rx.length; i++)
			{
				sprintf(log_msg,"[%d]%f",i,info_in[i]);
				WriteLog(logCMFile,log_msg);
			}*/

			sdvd(g, flow_rx.es_ovr_n0 ,(long)flow_rx.length, info_in, info_out);
			
	
///*
/*			WriteLog(logCMFile, "Despres Viterbi integers");
			for (i=0; i<flow_rx.length/2; i++){
				sprintf(log_msg,"[%d]%d",i,info_out[i]);
				WriteLog(logCMFile,log_msg);
			}
//*/

			flow_tx.length=bin2char (info_out, flow_tx.info, flow_rx.length/2);

			//Prova de sortida del viterbi bytes
 			/*for (i=0; i<flow_tx.length; i++){
				sprintf(log_msg,"[%d]%d",i, flow_tx.info[i]);
				WriteLog(logCMFile, log_msg);  
			}*/

			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;

			if(GetFlowStatus(Viterbi_flow_tx))
			{
				n=WriteFlow(Viterbi_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
		
		}
		else
		{
//			sprintf(log_msg,"mal llegit, %d ",n);
//			WriteLog(logCMFile, log_msg);

			WriteLog(logCMFile, "Error  writing the flow");
		}
	}
	
	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Viterbi time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);

}



