#!/bin/bash


	
FILE=* #all files by default
LOGPATH=example-work/logs
XTERM=xterm
TAIL='tail -f'

APP=$1

if ! test -n "$APP"
then
	echo "Need waveform name as parameter."
	exit
fi

echo ""
echo "==== Opening logs for waveform: $APP === "
echo ""

if ! test -n "$2"
then
	echo "Viewing all files by default (modify with second argument)"
else
	FILE=$2
fi


if test -n "$3" 
then
	LOGPATH = $3
fi

echo "Using path $LOGPATH (modify with third argument)"
echo ""

if ! test -d $LOGPATH
then
	echo "Error directory $LOGPATH does not exist"
	exit
fi

for i in $LOGPATH/$FILE.$APP.log
do
	echo "Opening xterm for $i..."
	$XTERM -e $TAIL $i &
done

