
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/** @defgroup exec_status P-HAL Execution Status
 *
 * This constants define the objects Execution Status
 * @{
 */ 
#define PHAL_STATUS_INIT	2
#define PHAL_STATUS_RUN		3
#define PHAL_STATUS_PAUSE	4
#define PHAL_STATUS_STOP	6
  
/** @} */ 

/** @defgroup others Other Constants
 *
 * @{
 */
#define FLOW_READ_ONLY		1
#define FLOW_WRITE_ONLY		2
#define FLOW_READ_WRITE		3

/** @} */

#define STAT_TYPE_CHAR	1
#define STAT_TYPE_UCHAR	2
#define STAT_TYPE_FLOAT	3
#define STAT_TYPE_INT	4
#define STAT_TYPE_SHORT	5


#define Log(a) ( LogWrite(1,a) )

/* ========================================
              PHAL-SW_API FUNCTIONS
   ========================================
*/
int InitPHAL();
void ClosePHAL();

int CreateItf(char *name, int mode);
int CloseItf(int fd);

int ReadItf(int fd, void *buffer, int size);
int WriteItf(int fd, void *buffer, int size);

void Set_ExecInterval(unsigned short ObjectId, int msec);
int Status(void);

int InitParamFile(void);
int GetParam (char *ParamName, void *ParamValue, char ParamType, int ParamLen);
		
int InitStat (char *StatName, char StatType, int StatSize);
int CloseStat (int StatId);
int SetStatsValue (int StatId, void * Value, int Size);
int GetStatsValue (int StatId, void * Buffer, int BuffByteSize);

int GetTstamp (void);
int LogWrite (int LogId, char *str);

void Relinquish(int nslots);
