#ifndef DAEMON_INCLUDED
#define DAEMON_INCLUDED

/** @defgroup daemon P-HAL Daemon Tools
* @ingroup common_phal
*
* This object is used to manage common daemon functionalities.
*
* When created, the object initializes the hwapi library 
* and creates input and output interface towards the front-end.
*
* User can add functions associated with packet types and 
* use a processcmd() function to select one of them when a 
* new packet (command) is received.
*
* Functions to send/rcv packets from the in/out main interfaces
* are also provided.
* @{
*/ 
#define T daemon_o

typedef struct T *T;

T 	daemon_new (dmid_t daemon_code);

void 	daemon_delete (T * daemon);

void 	daemon_relinquish ();

int 	daemon_addcmd (T daemon, cmd_t cmd,
		     int call (T mydaemon));
		    
int 	daemon_rcvpkt (T daemon);

int 	daemon_sendto (T daemon, cmd_t cmd,
		     peid_t pe, dmid_t destdaemon);
		     
int 	daemon_processcmd (T daemon);

pkt_o 	daemon_pkt (T daemon);

int utils_create_attach_ext_bi(int id, int size, int *fd_w, int *fd_r);

/** @} */ 
#undef T
#endif /*  */
