#ifndef PHITF_INCLUDED
#define PHITF_INCLUDED

#define T phitf_o

/** @defgroup P-HAL Interface Propierties
 *
 * @ingroup common_phal
 *
 * @todo Define this
 * @todo rtcitf reqs??
 * 
 * P-HAL Interface
 */

typedef struct T *T;

struct T
{
	char mode;

	itfid_t id;
	itfid_t remote_id;
	objid_t remote_obj_id;
	xitfid_t xitf_id;
	
	float bw_req;

	str_o name;
	str_o remotename;
	str_o remoteobjname;
};

struct topkt
{
	char mode;
	itfid_t id;
	itfid_t remote_id;
	objid_t remote_obj_id;
	xitfid_t xitf_id;
	float bw_req;
};

T phitf_new (char mode);
void phitf_delete(T *itf);

T phitf_dup(T itf);
//int 	phitf_sizeof (T itf);

int phitf_isinternal(T itf);

int phitf_iswriteonly(T itf);
int phitf_isreadonly(T itf);
int phitf_isreadwrite(T itf);

int phitf_findname(const void *x, const void *member);

/* pkt <-> obj functions */
int phitf_topkt(void *x, char **start, char *end);
void * phitf_newfrompkt(char **start, char *end);

/* unprotected functions */
void phitf_xdelete(void **x);
void * phitf_xdup(const void *x);
//int 	phitf_itfsizeof (const void *x);


/** @} */
#undef T  
#endif /*  */
