
/** @defgroup cmds_stats STATS Input Commands
 *
 * STATS Sensor input commands description.
 * @ingroup commands
 * @{
 */

/** @defgroup cmds_stats_stact Stat Value Action
 *
 * Action Request command to STATS Sensor (Get or Modify a variable value).
 *
 * @{
 */

/** SET Command Constant
 */
#define STATS_STSET			1
/** GET Command Constant
 */
#define STATS_STGET			2

int stats_incmd_stact(daemon_o daemon);


/** @} */ /* end cmds_stats_stact */


/** @defgroup cmds_stats_initack Stat/Parameters Initialization Acknowledgement 
 *
 * This command is issued when the initialization of an statistic variable
 * or the parameters file has been successfully realized by the STATS MANAGER.
 *
 * @ingroup cmds_stats
 * @{
 */


/** STAT INIT OK Command Constant
 */
#define STATS_STINITOK		3

/** STAT INIT ERROR Command Constant
 */
#define STATS_STINITERR		4

/** PARAMETERS FILE INIT OK Command Constant 
 */
#define STATS_PMINITOK		5

/** PARAMETERS FILE INIT ERROR Command Constant 
 */
#define STATS_PMINITERR	 	6

/** LOG INIT OK Command Constant 
 */
#define STATS_LOGINITOK		9

/** LOG INIT ERROR Command Constant 
 */
#define STATS_LOGINITERR	10


int stats_incmd_initack(daemon_o daemon);

/** @} */


/** @defgroup stats_cmds_pmval Parameter Value Request Answer
 *
 * This command carries the value of a requested initialization parameter.
 *
 * @ingroup cmds_stats
 *
 * @{
 */

/** PARAMETER VALUE OK Command Constant
 */
#define STATS_PMVALOK		7

/** PARAMETER VALUE ERROR Command Constant
 */
#define STATS_PMVALERR		8



int stats_incmd_pmval(daemon_o daemon);

/** @} */

/** @} */







