#ifndef VAR_INCLUDED
#define VAR_INCLUDED

#define T var_o

/** @defgroup var P-HAL Object Stat/Param
 * @ingroup common_obj
 *
 * This object is used to deal with P-HAL variables (statistics or parameters).
 * It allows to access its name, id and value 
 * 
 * @todo Check values methods
 *
 * @{
 */


typedef struct T *T;

struct T
{
  str_o name;
  varid_t id;
  vartype_t type;
};


T 		var_new (varsz_t size, vartype_t type);  

void 		var_delete (T * x);

int             var_bsize (T x);

varsz_t		var_setvalue (T x, void *value, varsz_t size);

void *		var_getvalue (T x);

int 		var_writetohwapi (T x);
  
int 		var_readfromhwapi (T x);

void 		var_printstr (T x, char *str);


/* pkt <-> obj functions */
void * 		var_newfrompkt (char **start, char *end);
int		var_topkt (void *x, char **start, char *end);

/* searching functions */
int		var_findid (const void *x, const void *member);
int		var_findname (const void *x, const void *member);

/* unprotected functions */
void var_xdelete (void **x);
void * var_xdup (const void *x);
int var_xsizeof (const void *x);


/** @} */ 
#undef T  
#endif /*  */
