#include <stdlib.h>
#include <string.h>

#include "phal_hw_api.h"

#include "phid.h"
#include "swman.h"

#include "str.h"
#include "set.h"
#include "rtcobj.h"
#include "phitf.h"
#include "phobj.h"

#include "downexe.h"

#define T downexe_o

/** Constructor
 */
T downexe_new ()
{
	T exe;

	NEW (exe);
	if (!exe) {
		return NULL;
	}
	exe->name = str_new ();
	exe->objects = Set_new (0, NULL);
	if (!exe->name || !exe->objects)
	{
		downexe_delete (&exe);
		return NULL;
	}
	return exe;
}

/** Destructor
 */
void downexe_delete(T * exe)
{
	assert (exe);
	assert (*exe);
	
	if ((*exe)->name) {
		str_delete(&(*exe)->name);
	}
	if ((*exe)->objects) {
		Set_destroy(&(*exe)->objects, phobj_xdelete);
	}
	if ((*exe)->data) {
		free((*exe)->data);
	}

	free(*exe);
	exe = NULL;
}

/* Compares string x with executable name in member */
int downexe_findname(const void *x, const void *member)
{
	T exe = (T) member;

	assert (x && member);

	return str_scmp(exe->name, (char *) x);

}

