#include <stdlib.h>
#include <string.h>

#include "phid.h"

#include "str.h"
#include "set.h"
#include "rtcobj.h"
#include "phitf.h"
#include "phobj.h"

#include "phal_hw_api.h"

#define T rtcobj_o


/** Constructor
 */
T rtcobj_new ()
{
	T obj;

	NEW (obj);
	return obj;
}

/** Destructor 
 */
void rtcobj_delete(T * obj)
{
	assert (*obj);

	free(*obj);
	obj = NULL;
}

/** Duplicate object
 */
T rtcobj_dup (T obj)
{
	T newobj;

	assert (obj);

	NEW (newobj);
	if (newobj)
	{
		memcpy (newobj, obj, sizeof (struct rtcobj_o));
	}

	return newobj;
}

int rtcobj_sizeof(T obj)
{
	return sizeof(struct rtcobj_o);
}

#define RTCOBJ_MIN_PKT_SZ       (sizeof (struct rtcobj_o))

int rtcobj_topkt(void *x, char **start, char *end)
{
	assert (x && start && end);
	assert (end >= *start);

	if ((end - *start) < RTCOBJ_MIN_PKT_SZ) {
		return 0;
	}

	memcpy(*start, x, sizeof(struct rtcobj_o));
	*start += sizeof(struct rtcobj_o);

	return 1;
}

void * rtcobj_newfrompkt(char **start, char *end)
{
	assert (start && end);
	assert (end >= *start);

	T obj;

	if (end - *start < RTCOBJ_MIN_PKT_SZ) {
		return NULL;
	}

	NEW (obj);
	if (!obj) {
		return NULL;
	}

	memcpy(obj, *start, sizeof(struct rtcobj_o));
	*start += sizeof(struct rtcobj_o);
	
	return obj;
}

void rtcobj_xdelete(void **x)
{
	rtcobj_delete((T*) x);
}
void * rtcobj_xdup(const void *x)
{
	return (void *) rtcobj_dup((T) x);
}
int rtcobj_xsizeof(const void *x)
{
	return rtcobj_sizeof((T) x);
}

