#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "crm.h"

extern unsigned b[Mmax][Mmax];
extern int m_sort[Mmax];

extern int N;

// sort processes in descending order of processing requirements
void sort_m(int M, int m[])
{
	//general
	int i, j;					// loop indices: i - row index, j - column index
	int idx_temp;				// temporary sort index
	int m_temp;
	int idx[Mmax];				// sort indices
	unsigned b_sortx[Mmax][Mmax];	// intermediate sorted b-matrix


	// initialization
	for (i=0; i<M; i++)
		idx[i] = i;

	for (i=0; i<M; i++)
		m_sort[i] = m[i];


	for (i=0; i<(M-1); i++)
	{
		for (j=0; j<(M-1); j++)
		{	// sort in descending order!
			if (m_sort[j+1] > m_sort[j])	// if m[j+1] > m[j]: interchange m[j+1] with m[j]
			{
				idx_temp = idx[j];
				idx[j] = idx[j+1];
				idx[j+1] = idx_temp;

				m_temp = m_sort[j];
				m_sort[j] = m_sort[j+1];
				m_sort[j+1] = m_temp;

			}
		}
	}

	//for (i=0; i<M; i++)
	//	printf("\nm_sort[%d] = %d",i,m[idx[i]]);	// debugging


	for (i=0; i<M; i++)
		for (j=0; j<M; j++)
			b_sortx[i][j] = b[idx[i]][j];
	
	for (i=0; i<M; i++)
		for (j=0; j<M; j++)
			b[j][i] = b_sortx[j][idx[i]];


	//for (i=0; i<M; i++)	// debugging
	//{
	//	for (j=0; j<M; j++)
	//		printf("\nb[%d][%d] = %u",i,j,b[i][j]);
	//}

}


// sort processes in descending order of bandwith requirements
void sort_b(int M, int m[])
{
	//general
	int i, j;						// loop indices: i - row index, j - column index
	int n = 0;						// counter variable used for sorting processes
	unsigned b_aux[Mmax][Mmax];		// b-matrix copy
	unsigned b_sortx[Mmax][Mmax];	// intermediate sorted b-matrix
	int ord[Mmax];
	int stop = 0;
	unsigned aux;
	int i_indx = 0;
	int j_indx = 0;

	// initialization
	for (i=0; i<M; i++)
		ord[i] = -1;

	for (i=0; i<M; i++)
		for (j=0; j<M; j++)
			b_aux[i][j] = b[i][j];


	while (stop == 0)
	{
		stop = 1;
		aux = 0;
		for (i=0; i<(M-1); i++)
		{
			for (j=i+1; j<M; j++)
			{
				if (b_aux[i][j] > aux)	// if m[j+1] > m[j]: interchange m[j+1] with m[j]
				{
					aux = b_aux[i][j];
					i_indx = i;
					j_indx = j;
					stop = 0;	// continue
				}
			}
		}
		if (stop == 0)
		{
			b_aux[i_indx][j_indx] = 0;
			if (ord[i_indx] == -1)
			{
				ord[i_indx] = n;
				n++;
			}
			if (ord[j_indx] == -1)
			{
				ord[j_indx] = n;
				n++;
			}
		}
	}

	// debugging
	//for (i=0; i<M; i++)
	//{
	//	printf("\n");
	//	for (j=0; j<M; j++)
	//		printf("%u\t",b[i][j]);
	//}
	//printf("\n");

	//for (i=0; i<M; i++)
	//	printf("%d  ",ord[i]);
	//printf("\n");

	for (i=0; i<M; i++)
		for (j=0; j<M; j++)
			b_sortx[ord[i]][j] = b[i][j];

	for (i=0; i<M; i++)
		for (j=0; j<M; j++)
			b[j][ord[i]] = b_sortx[j][i];

	for (i=0; i<M; i++)
		m_sort[ord[i]] = m[i];

	// debugging
	//for (i=0; i<M; i++)
	//{
	//	printf("\n");
	//	for (j=0; j<M; j++)
	//		printf("%u\t",b[i][j]);
	//}

	// debugging
	//for (i=0; i<M; i++)
	//	printf("\nm[%d]      = %d",i,m[i]);

	// debugging
	//for (i=0; i<M; i++)
	//	printf("\nm_sort[%d] = %d",i,m_sort[i]);
	//printf("\n----------------------------------------------------------");

}
