#include <stdlib.h>
#include <string.h>

#include "phal_hw_api.h"
#include "phal_hw_api_man.h"

#include "phid.h"

#include "str.h"
#include "set.h"
#include "log.h"

#define T log_o

struct T {
	int id;
	int fd;
	str_o name;
};


char string[128];

T log_new(int id, char *name) {
	T log;
	int len;
		
	NEW(log);
	if (!log) {
		return NULL;
	}
	
	sprintf(string, "%s/%s.%s", BASE_LOG_PATH, name, LOG_EXT);
	log->fd = hwapi_res_open(string, FLOW_WRITE_ONLY, &len);
	if (log->fd < 0) {
		log_delete(&log);
		return NULL;
	}
	/* set position to the end */
	hwapi_res_read(log->fd, NULL, len);
	log->name = str_snew (name);
	if (!log) {
		log_delete(&log);
		return NULL;
	}
	
	log->id = id;
	
	return log;
}

void log_delete (T * log) {
	if ((*log)->name) {
		str_delete(&(*log)->name);
	}

	if ((*log)->fd > 0) {
		hwapi_res_close((*log)->fd);
	}
	free(*log);
	log=NULL;
}

T log_dup (T log) {
	T newlog;
	
	assert (log);
	
	NEW(newlog);
	if (!newlog) {
		return NULL;
	}
	newlog->fd = log->fd;
	newlog->id = log->id;
	newlog->name = str_dup (log->name);

	if (!newlog->name) {
		log_delete(&newlog);
		return NULL;
	}
	
	return newlog;
}

/*
T log_getId(T log) {
	assert (log);
	return log->id;
}
*/

int log_Write(T log, char *output) {
	assert (log);
	
	//if (log->id == 1) 
	//	printf ("logging %s\n", output);
	
	return hwapi_res_write(log->fd, output, strlen(output));
}

int log_findid(const void *x, const void *member) 
{
	T log = (T) member;

	return (*((int *) x) != log->id);
}


