#ifndef PARSER_INCLUDED
#define PARSER_INCLUDED
#define T cfg_o
#define S sect_o
#define K key_o


#define PARAM_CHAR   10
#define PARAM_INT    30
#define PARAM_HEX    32
#define PARAM_FLOAT  4
#define PARAM_STRING 6

typedef struct T *T;
typedef struct K *K;
typedef struct S *S;


/** @defgroup cfg Config Parser library
 * @ingroup common_base
 * @{
 */

T       cfg_new (char *buffer, int offset);
void    cfg_delete (T * cfg);
S       cfg_default_sect (T cfg);
Set_o   cfg_sections(T cfg);

void    sect_delete(S * sect);
Set_o   sect_subsects(S sect);
Set_o   sect_keys (S sect);
char *  sect_title (S sect);

void    key_delete (K * key);
int     key_nofelems (K key, int type);
int     key_type (K key);
void *  key_value (K key, int size, int type);

int     sect_findtitle (const void *data, const void *x);
int     key_findname (const void *data, const void *x);

void cfg_xdelete (void **x);
void sect_xdelete (void **x);
void key_xdelete (void **x);

/** @} */

#undef T
#undef S
#undef K
#endif


