#ifndef str_INCLUDED
#define str_INCLUDED


#define T str_o


/** @defgroup str P-HAL str
 *
 * @ingroup common_phal
 *
 * Object to manage strings. 
 *
 * @{
 */ 

typedef struct T *T;



T       str_new (void);
T       str_snew (char *s);
void    str_delete (T *str);

char *  str_str (T str);
int     str_set (T str, char *src);
int     str_get (T str, char *dst, int max_len);

int     str_cmp (T x, T y);
int     str_scmp (T x, char *str);

T       str_dup (T str);
int     str_cpy (T dst, T src);

int     str_sizeof(T str);


/* unprotected functions */
void * str_newfrompkt (char **start, char *end);
int     str_topkt (void *x, char **start, char *end);
void str_xdelete (const void *x);
void * str_xdup (const void *x);
int str_xsizeof (const void *x);

/** @} */ 
#undef T
#endif /*  */
