#include "pilot_cm.h"

int main(int argc, char **argv)
{

  	int n=0;
	int c;
    
	printf("PILOT  module started\n");

	if (argc > 1)
	{
		while((c = getopt (argc, argv, "m:s:d:p:")) != -1)//d:
		switch(c){
		case 'm':
        		pilot_id=atoi(optarg);
			printf("Pilot id: %d\n",pilot_id);
        	break;
		case 's':
        		smap_id=atoi(optarg);
			printf("Smap id: %d\n",smap_id);
        	break;		
		case 'd':
        		ifft_id=atoi(optarg);
			printf("Ifft id: %d\n",ifft_id);
	
        	break;
		case 'p':
        		estadisticas_id=atoi(optarg);
			printf("Estadisticas id: %d\n",estadisticas_id);
	
        	break;
	
		case '?':
        	if (isprint (optopt))
          		fprintf (stderr, "CONTROL->ERROR: Unknown option `-%c'.\n", optopt);
        	else
          		fprintf (stderr, "CONTROL->ERROR: Oops! `\\x%x'.\n", optopt);
        	exit(1);

		default:
        	exit(1);
		}
	}

	if (smap_id<0 || ifft_id<0 || pilot_id<0 || estadisticas_id<0)
	{
		printf("Need two mandatory parameter: -m <pilot_id> -s <smap_id> -d <ifft_id> -p <estadisticas_id>\n");
		exit(0);
	}
	//Init Communications Manager
	printf("Init communications manager\n");

	sprintf(modulename,"PILOT");
	n=InitCommManagerN(pilot_id,modulename);
	if(n<0) return(-1);


	printf("Register module PILOT: OK\n");

	//For ever loop
	while (1) {
		/*Get testbed testbed_status*/
		testbed_status=TestBedStatus();

		//INIT SECTION
		if (testbed_status==TB_INIT) 
		{
			PILOT_Init();
			PILOT_Stat_Init();
		}

		//RUN SECTION
		if (testbed_status==TB_RUN) 
		{
			PILOT_Stat_Run0();
			PILOT_Run();
			PILOT_Stat_Run1();
		}

		//STOP SECTION
		if (testbed_status==TB_STOP) 
		{
			PILOT_Stop();
			PILOT_Stat_Stop();
		}
	}

	return(1);

}
