#include "pilot_cm.h"



/**********************************************************
INIT
**********************************************************/
void PILOT_Init()
{
  struct flow_config fconf,fconf2,fconf3;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create Smapflow_rx\n");
	//Create CHANNELflow_rx
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1600;
	fconf.magic = (smap_id*pilot_id)%(smap_id+pilot_id);
	fconf.name = "Pilot_flow_rx";
	Pilot_flow_rx = NewFlow(pilot_id, smap_id, fconf);
	if (Pilot_flow_rx<0) UnrecoveryError("Could not create flow with Smap");
	WriteLog(logCMFile, "Pilotflow_rx: OK\n");


	WriteLog(logCMFile, "Create Pilotflow_tx\n");
	//Create Ifftflow_tx

	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 3600;
	fconf2.magic = (pilot_id*ifft_id)%(pilot_id+ifft_id);
	fconf2.name = "Pilot_flow_tx";
	Pilot_flow_tx = NewFlow(pilot_id, ifft_id, fconf2);
	if (Pilot_flow_tx<0) UnrecoveryError("Could not create flow with Ifft");
	WriteLog(logCMFile, "Pilotflow_tx: OK\n");


	WriteLog(logCMFile, "Create Pilotflow_tx2\n");
	//Create Estadisticasflow_tx

/*	fconf3.rw = FLOW_READ_WRITE;
	fconf3.type = 0;
	fconf3.options = 0;
	fconf3.max_size = 3600;
	fconf3.magic = (pilot_id*estadisticas_id)%(pilot_id+estadisticas_id);
	fconf3.name = "Pilot_flow_tx2";
	Pilot_flow_tx2 = NewFlow(pilot_id, estadisticas_id, fconf3);
	if (Pilot_flow_tx2<0) UnrecoveryError("Could not create flow with Estadisticas");
	WriteLog(logCMFile, "Pilotflow_tx2: OK\n");
*/
	time_slot=0;
	}

/*************************************************************
STOP
************************************************************/
void PILOT_Stop() {

	DeleteFlow(Pilot_flow_rx);
	WriteLog(logCMFile, "DeleteFlow Pilot_flow_rx\n");

	DeleteFlow(Pilot_flow_tx);
	WriteLog(logCMFile, "DeleteFlow Pilot_flow_tx\n");

	DeleteFlow(Pilot_flow_tx2);
	WriteLog(logCMFile, "DeleteFlow Pilot_flow_tx2\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(pilot_id);

	exit(0);
}

smap2pilot flow_rx;
pilot2ifft flow_tx;
pilot2estadisticas flow_tx2;

/****************************************************************
RUN
****************************************************************/
void PILOT_Run(){

	gettimeofday(&tm1,NULL);
	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;
	float real[256], imag[256];
	symbol piloto[8];





	if(GetFlowStatus(Pilot_flow_rx))
	{
//		sprintf(log_msg,"timeslot:%d",time_slot);
//		WriteLog(logCMFile, log_msg);

		n=ReadFlow(Pilot_flow_rx,sizeof(flow_rx),&flow_rx);
		//printf("readflow: %d\n", n);

		WriteLog(logCMFile, log_msg);

		if (n>0)
		{




		/*printf("antes del for\n");
			for (i=0; i<192; i++)
			{
				printf("real [%d]: %f\n",i,flow_rx.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

				printf("imag [%d]: %f\n",i,flow_rx.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);

			}*/

		for (i=0;i<192;i++){
			real[i]=flow_rx.asymbol[i].re;
			imag[i]=flow_rx.asymbol[i].im;
			flow_tx2.asymbol[i].re=flow_rx.asymbol[i].re;
			flow_tx2.asymbol[i].im=flow_rx.asymbol[i].im;
		}
		//FUNCION DE AÑADIR CANALES PILOTO AQUI!!!!!
		pilotcode(piloto,1);
		crear_simbolo(piloto,real,imag);

		flow_tx.mod=flow_rx.mod;
		flow_tx.mode=flow_rx.mode;
		flow_tx.rsolomon=flow_rx.rsolomon;
		flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;
		flow_tx.cconv=flow_rx.cconv;
		flow_tx.num_tx=flow_rx.num_tx;
		for (i=0;i<256;i++){
			flow_tx.asymbol[i].re=real[i];
			flow_tx.asymbol[i].im=imag[i];
		}

		flow_tx2.length=flow_rx.length;
		flow_tx2.num_tx=flow_rx.num_tx;
		flow_tx2.mod=flow_rx.mod;

		/*printf("antes de enviar\n");
			for (i=0; i<256; i++)
			{
				printf("real [%d]: %f\n",i,flow_tx.asymbol[i].re);
				//WriteLog(logCMFile,log_msg);

				printf("imag [%d]: %f\n",i,flow_tx.asymbol[i].im);
				//WriteLog(logCMFile,log_msg);

			}*/
		if(GetFlowStatus(Pilot_flow_tx))

			{
				n=WriteFlow(Pilot_flow_tx,sizeof(flow_tx),&flow_tx);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}
		/*
		if(GetFlowStatus(Pilot_flow_tx2))

			{
				n=WriteFlow(Pilot_flow_tx2,sizeof(flow_tx2),&flow_tx2);
				//sprintf(prueba,"flow_tx: %f\n",flow_tx);
				//write (1,prueba,sizeof(prueba));
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");
			}

		*/

		}
		else
		{
		 	WriteLog(logCMFile, "There is no flow to read");
		}

	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Pilot time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}

