#include "rsol_cm.h"
#include "rsol_code.h"


/**********************************************************
INIT
**********************************************************/
void RSOL_Init()
{
 	struct flow_config fconf,fconf2;

	printf("From now on any message is sent to log file\n");

	/*Log file: from now on any message is sent to log file*/
	logCMFile=CreateLog();
	if (logCMFile<0)
		UnrecoveryError("Trouble creating log file");

	WriteLog(logCMFile, "Create RSolflow\n");
	//Create RSolflow
	fconf.rw = FLOW_READ_WRITE;
	fconf.type = 0;
	fconf.options = 0;
	fconf.max_size = 1500;
	fconf.magic = (rando_id*rsol_id)%(rando_id+rsol_id);
	fconf.name = "RSol_flow_rx";
	RSol_flow_rx = NewFlow(rsol_id, rando_id, fconf);
	if (RSol_flow_rx<0) UnrecoveryError("Could not create flow with RSol");
	WriteLog(logCMFile, "RSolflow_rx: OK\n");


	WriteLog(logCMFile, "Create RSolflow2\n");
	//Create RSolflow2
	fconf2.rw = FLOW_READ_WRITE;
	fconf2.type = 0;
	fconf2.options = 0;
	fconf2.max_size = 1500;
	fconf2.magic = (rsol_id*cconv_id)%(rsol_id+cconv_id);
	fconf2.name = "RSol_flow_tx";
	RSol_flow_tx = NewFlow(rsol_id, cconv_id, fconf2);
	if (RSol_flow_tx<0) UnrecoveryError("Could not create flow with Cconv");
	WriteLog(logCMFile, "RSolflow_tx: OK\n");
	time_slot=0;


	init_exp_table();	//lookup tables GF(2^8) Init
	compute_genpoly (NPAR, genPoly); //Genpoly computation
}

/*************************************************************
STOP
************************************************************/
void RSOL_Stop() {

	DeleteFlow(RSol_flow_rx);
	WriteLog(logCMFile, "DeleteFlow RSol_flow_rx\n");

	DeleteFlow(RSol_flow_tx);
	WriteLog(logCMFile, "DeleteFlow RSol_flow_tx\n");

	WriteLog(logCMFile, "Close CommManager\n");
	CloseCommManager(rsol_id);

	exit(0);
}
rand2rsolomon flow_rx;
rsol2cconv flow_tx;

/****************************************************************
RUN
****************************************************************/
void RSOL_Run(){
	gettimeofday(&tm1,NULL);
    	WriteLog(logCMFile, "Counter start\n");
    	time_slot=GetTimeStamp();

	int n,i;

	unsigned char msg[K_LENGTH];
	unsigned char codeword[N_LENGTH];


	if(GetFlowStatus(RSol_flow_rx))
	{
		n=ReadFlow(RSol_flow_rx,sizeof(flow_rx),&flow_rx);
		if(n>0)
		{
//			sprintf(log_msg,"timeslot, %d p=%d, rsolomon %d",time_slot,n,flow_rx.rsolomon);
//			WriteLog(logCMFile, log_msg);

			WriteLog(logCMFile, "HE REBUT!!!!!!!!!!!!!\n");
			if (flow_rx.mod!=1){	//bypass RS for BPSK modulation


				//Show in msg
//				sprintf(log_msg,"Msg_bits");
//				WriteLog(logCMFile, log_msg);
/*				for (i=0; i<flow_rx.length; i++){
					sprintf(log_msg,"[%d]%d",i,flow_rx.info[i]);
					WriteLog(logCMFile,log_msg);
				}*/

				fillzero(flow_rx.info,msg,&flow_rx.length); //Shortened
				//Constructed msg
//				sprintf(log_msg,"Msg_bytes");
//				WriteLog(logCMFile, log_msg);
/*				for (i=0; i<K_LENGTH; i++){
					sprintf(log_msg,"[%d]%d",i,msg[i]);
					WriteLog(logCMFile,log_msg);
				}*/


				encode_data (msg, K_LENGTH, codeword);
				//Show Codeword
//				sprintf(log_msg,"Codeword");
//				WriteLog(logCMFile, log_msg);
/*				for (i=0; i<N_LENGTH; i++){
					sprintf(log_msg,"[%d]%d",i,codeword[i]);
					WriteLog(logCMFile,log_msg);
				}*/


				delredundant(codeword,flow_rx.rsolomon,flow_rx.length);
				//Shortened and Puncturing
//				sprintf(log_msg,"Shortened & Puncturing");
//				WriteLog(logCMFile, log_msg);
				for (i=0; i<(flow_rx.rsolomon+flow_rx.length); i++){
					flow_tx.info[i]=codeword[i];
				//	sprintf(log_msg,"[%d]%d",i,codeword[i]);
				//	WriteLog(logCMFile,log_msg);
				}

				flow_tx.length=flow_rx.length+flow_rx.rsolomon;
				sprintf(log_msg,"flow_txlength=%d",flow_tx.length);
				WriteLog(logCMFile,log_msg);


			}
			else
			{
				//If the modulation used is BPSK, the info in is copied to the info out

				for (i=0; i< flow_rx.length; i++)
				{
					flow_tx.info[i]=flow_rx.info[i];
				}
				flow_tx.info[flow_rx.length]=0;
				flow_tx.length=flow_rx.length+1;


			}
/*
			WriteLog(logCMFile, "Transmited Codeword");
			for (i=0; i<flow_tx.length; i++)
			{
				sprintf(log_msg,"[%d]%d",i,flow_tx.info[i]);
				WriteLog(logCMFile, log_msg);
			}
*/
			flow_tx.cconv=flow_rx.cconv;
			flow_tx.interl=flow_rx.interl;
			flow_tx.mod=flow_rx.mod;
			flow_tx.mode=flow_rx.mode;
			flow_tx.rsolomon=flow_rx.rsolomon;
			flow_tx.es_ovr_n0=flow_rx.es_ovr_n0;

			if(GetFlowStatus(RSol_flow_tx))
			{
				n=WriteFlow(RSol_flow_tx,sizeof(flow_tx),&flow_tx);
				if(n<0)
					WriteLog(logCMFile, "Error  writing the flow");

				WriteLog(logCMFile, "He escrit\n");

			}

		}
 		else
		{
			WriteLog(logCMFile, "There is no flow to read");

		}
	}
	else {
		WriteLog(logCMFile, "NO DATA!!!");
	}

	gettimeofday(&tm2,NULL);
	sprintf(log_msg,"Rsolomon time %d us",(tm2.tv_usec-tm1.tv_usec));
	WriteLog(logCMFile, log_msg);

	Relinquish(1);
}
